# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "11" />
#<program4xi program = "event4xi5test.py">
#<abstract4xi abstract = "tests event4xi"/>
#<verify4xi verification = "11" target = "event4xi5test.py"/>
#<contextualize4xi context = "event4xi.py"/>
#<use4xi usage = "
# SET:
# 
# RUN:
# > python event4xi5test.py > E:\scope4xi\041721\zap\work\txt\event4xi5test.txt
#
# ANALYZE:
#
# sense-test-event4xi5test.xml     <-- trace in XML
# reason-test-event4xi5test.xml
# ace-test-event4xi5test.xml
# event4xi5test.txt                <-- OF EVENT4XI5TEST
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4moduletesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'event4xi5test']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  

from ctypes import Structure, c_double

#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arena4xi import Arena4Xi
from pipe4xi import Pipe4Xi   
from queue4xi import Queue4Xi                                                                                      


# -------------------------------------------------------------------------------------------------
# Event classes and functions from event modules                           
# -------------------------------------------------------------------------------------------------
from event4xi import Event4Xi
from event4xi import create2event4xi
from event4xi import get2eventinfo4xi
from event4xi import release2event4xi
from event4xi import retain2event4xi
from event4xi import set2event4xi
from event4xi import set2eventcallback4xi
from event4xi import trace2event4xi
from event4xi import wait2event4xi

from apu2event4xi import APU2Event4Xi                                                                 
from bpu2event4xi import BPU2Event4Xi
from cpu2event4xi import CPU2Event4Xi
from dpu2event4xi import DPU2Event4Xi
from epu2event4xi import EPU2Event4Xi
from fpu2event4xi import FPU2Event4Xi
from gpu2event4xi import GPU2Event4Xi
from hpu2event4xi import HPU2Event4Xi
from ipu2event4xi import IPU2Event4Xi
from jpu2event4xi import JPU2Event4Xi
from kpu2event4xi import KPU2Event4Xi
from lpu2event4xi import LPU2Event4Xi
from mpu2event4xi import MPU2Event4Xi
from npu2event4xi import NPU2Event4Xi
from opu2event4xi import OPU2Event4Xi
from ppu2event4xi import PPU2Event4Xi
from qpu2event4xi import QPU2Event4Xi
from rpu2event4xi import RPU2Event4Xi
from spu2event4xi import SPU2Event4Xi
from tpu2event4xi import TPU2Event4Xi
from upu2event4xi import UPU2Event4Xi
from vpu2event4xi import VPU2Event4Xi
from xpu2event4xi import XPU2Event4Xi
from wpu2event4xi import WPU2Event4Xi
from ypu2event4xi import YPU2Event4Xi
from zpu2event4xi import ZPU2Event4Xi


from apu2event4xi import create2event4apu
from bpu2event4xi import create2event4bpu
from cpu2event4xi import create2event4cpu
from dpu2event4xi import create2event4dpu
from epu2event4xi import create2event4epu
from fpu2event4xi import create2event4fpu
from gpu2event4xi import create2event4gpu
from hpu2event4xi import create2event4hpu
from ipu2event4xi import create2event4ipu
from jpu2event4xi import create2event4jpu
from kpu2event4xi import create2event4kpu
from lpu2event4xi import create2event4lpu
from mpu2event4xi import create2event4mpu
from npu2event4xi import create2event4npu
from opu2event4xi import create2event4opu
from ppu2event4xi import create2event4ppu
from qpu2event4xi import create2event4qpu
from rpu2event4xi import create2event4rpu
from spu2event4xi import create2event4spu
from tpu2event4xi import create2event4tpu
from upu2event4xi import create2event4upu
from vpu2event4xi import create2event4vpu
from xpu2event4xi import create2event4xpu
from wpu2event4xi import create2event4wpu
from ypu2event4xi import create2event4ypu
from zpu2event4xi import create2event4zpu

from apu2event4xi import get2eventinfo4apu
from bpu2event4xi import get2eventinfo4bpu
from cpu2event4xi import get2eventinfo4cpu
from dpu2event4xi import get2eventinfo4dpu
from epu2event4xi import get2eventinfo4epu
from fpu2event4xi import get2eventinfo4fpu
from gpu2event4xi import get2eventinfo4gpu
from hpu2event4xi import get2eventinfo4hpu
from ipu2event4xi import get2eventinfo4ipu
from jpu2event4xi import get2eventinfo4jpu
from kpu2event4xi import get2eventinfo4kpu
from lpu2event4xi import get2eventinfo4lpu
from mpu2event4xi import get2eventinfo4mpu
from npu2event4xi import get2eventinfo4npu
from opu2event4xi import get2eventinfo4opu
from ppu2event4xi import get2eventinfo4ppu
from qpu2event4xi import get2eventinfo4qpu
from rpu2event4xi import get2eventinfo4rpu
from spu2event4xi import get2eventinfo4spu
from tpu2event4xi import get2eventinfo4tpu
from upu2event4xi import get2eventinfo4upu
from vpu2event4xi import get2eventinfo4vpu
from xpu2event4xi import get2eventinfo4xpu
from wpu2event4xi import get2eventinfo4wpu
from ypu2event4xi import get2eventinfo4ypu
from zpu2event4xi import get2eventinfo4zpu


from apu2event4xi import release2event4apu
from bpu2event4xi import release2event4bpu
from cpu2event4xi import release2event4cpu
from dpu2event4xi import release2event4dpu
from epu2event4xi import release2event4epu
from fpu2event4xi import release2event4fpu
from gpu2event4xi import release2event4gpu
from hpu2event4xi import release2event4hpu
from ipu2event4xi import release2event4ipu
from jpu2event4xi import release2event4jpu
from kpu2event4xi import release2event4kpu
from lpu2event4xi import release2event4lpu
from mpu2event4xi import release2event4mpu
from npu2event4xi import release2event4npu
from opu2event4xi import release2event4opu
from ppu2event4xi import release2event4ppu
from qpu2event4xi import release2event4qpu
from rpu2event4xi import release2event4rpu
from spu2event4xi import release2event4spu
from tpu2event4xi import release2event4tpu
from upu2event4xi import release2event4upu
from vpu2event4xi import release2event4vpu
from xpu2event4xi import release2event4xpu
from wpu2event4xi import release2event4wpu
from ypu2event4xi import release2event4ypu
from zpu2event4xi import release2event4zpu

from apu2event4xi import retain2event4apu
from bpu2event4xi import retain2event4bpu
from cpu2event4xi import retain2event4cpu
from dpu2event4xi import retain2event4dpu
from epu2event4xi import retain2event4epu
from fpu2event4xi import retain2event4fpu
from gpu2event4xi import retain2event4gpu
from hpu2event4xi import retain2event4hpu
from ipu2event4xi import retain2event4ipu
from jpu2event4xi import retain2event4jpu
from kpu2event4xi import retain2event4kpu
from lpu2event4xi import retain2event4lpu
from mpu2event4xi import retain2event4mpu
from npu2event4xi import retain2event4npu
from opu2event4xi import retain2event4opu
from ppu2event4xi import retain2event4ppu
from qpu2event4xi import retain2event4qpu
from rpu2event4xi import retain2event4rpu
from spu2event4xi import retain2event4spu
from tpu2event4xi import retain2event4tpu
from upu2event4xi import retain2event4upu
from vpu2event4xi import retain2event4vpu
from xpu2event4xi import retain2event4xpu
from wpu2event4xi import retain2event4wpu
from ypu2event4xi import retain2event4ypu
from zpu2event4xi import retain2event4zpu


from apu2event4xi import set2event4apu
from bpu2event4xi import set2event4bpu
from cpu2event4xi import set2event4cpu
from dpu2event4xi import set2event4dpu
from epu2event4xi import set2event4epu
from fpu2event4xi import set2event4fpu
from gpu2event4xi import set2event4gpu
from hpu2event4xi import set2event4hpu
from ipu2event4xi import set2event4ipu
from jpu2event4xi import set2event4jpu
from kpu2event4xi import set2event4kpu
from lpu2event4xi import set2event4lpu
from mpu2event4xi import set2event4mpu
from npu2event4xi import set2event4npu
from opu2event4xi import set2event4opu
from ppu2event4xi import set2event4ppu
from qpu2event4xi import set2event4qpu
from rpu2event4xi import set2event4rpu
from spu2event4xi import set2event4spu
from tpu2event4xi import set2event4tpu
from upu2event4xi import set2event4upu
from vpu2event4xi import set2event4vpu
from xpu2event4xi import set2event4xpu
from wpu2event4xi import set2event4wpu
from ypu2event4xi import set2event4ypu
from zpu2event4xi import set2event4zpu


from apu2event4xi import set2eventcallback4apu
from bpu2event4xi import set2eventcallback4bpu
from cpu2event4xi import set2eventcallback4cpu
from dpu2event4xi import set2eventcallback4dpu
from epu2event4xi import set2eventcallback4epu
from fpu2event4xi import set2eventcallback4fpu
from gpu2event4xi import set2eventcallback4gpu
from hpu2event4xi import set2eventcallback4hpu
from ipu2event4xi import set2eventcallback4ipu
from jpu2event4xi import set2eventcallback4jpu
from kpu2event4xi import set2eventcallback4kpu
from lpu2event4xi import set2eventcallback4lpu
from mpu2event4xi import set2eventcallback4mpu
from npu2event4xi import set2eventcallback4npu
from opu2event4xi import set2eventcallback4opu
from ppu2event4xi import set2eventcallback4ppu
from qpu2event4xi import set2eventcallback4qpu
from rpu2event4xi import set2eventcallback4rpu
from spu2event4xi import set2eventcallback4spu
from tpu2event4xi import set2eventcallback4tpu
from upu2event4xi import set2eventcallback4upu
from vpu2event4xi import set2eventcallback4vpu
from xpu2event4xi import set2eventcallback4xpu
from wpu2event4xi import set2eventcallback4wpu
from ypu2event4xi import set2eventcallback4ypu
from zpu2event4xi import set2eventcallback4zpu


from apu2event4xi import trace2event4apu
from bpu2event4xi import trace2event4bpu
from cpu2event4xi import trace2event4cpu
from dpu2event4xi import trace2event4dpu
from epu2event4xi import trace2event4epu
from fpu2event4xi import trace2event4fpu
from gpu2event4xi import trace2event4gpu
from hpu2event4xi import trace2event4hpu
from ipu2event4xi import trace2event4ipu
from jpu2event4xi import trace2event4jpu
from kpu2event4xi import trace2event4kpu
from lpu2event4xi import trace2event4lpu
from mpu2event4xi import trace2event4mpu
from npu2event4xi import trace2event4npu
from opu2event4xi import trace2event4opu
from ppu2event4xi import trace2event4ppu
from qpu2event4xi import trace2event4qpu
from rpu2event4xi import trace2event4rpu
from spu2event4xi import trace2event4spu
from tpu2event4xi import trace2event4tpu
from upu2event4xi import trace2event4upu
from vpu2event4xi import trace2event4vpu
from xpu2event4xi import trace2event4xpu
from wpu2event4xi import trace2event4wpu
from ypu2event4xi import trace2event4ypu
from zpu2event4xi import trace2event4zpu

from apu2event4xi import wait2event4apu
from bpu2event4xi import wait2event4bpu
from cpu2event4xi import wait2event4cpu
from dpu2event4xi import wait2event4dpu
from epu2event4xi import wait2event4epu
from fpu2event4xi import wait2event4fpu
from gpu2event4xi import wait2event4gpu
from hpu2event4xi import wait2event4hpu
from ipu2event4xi import wait2event4ipu
from jpu2event4xi import wait2event4jpu
from kpu2event4xi import wait2event4kpu
from lpu2event4xi import wait2event4lpu
from mpu2event4xi import wait2event4mpu
from npu2event4xi import wait2event4npu
from opu2event4xi import wait2event4opu
from ppu2event4xi import wait2event4ppu
from qpu2event4xi import wait2event4qpu
from rpu2event4xi import wait2event4rpu
from spu2event4xi import wait2event4spu
from tpu2event4xi import wait2event4tpu
from upu2event4xi import wait2event4upu
from vpu2event4xi import wait2event4vpu
from xpu2event4xi import wait2event4xpu
from wpu2event4xi import wait2event4wpu
from ypu2event4xi import wait2event4ypu
from zpu2event4xi import wait2event4zpu


# -------------------------------------------------------------------------------------------------
# Command queue modules                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi                                                                         
from commandqueue4xi import create2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi 
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi

from apu2commandqueue4xi import APU2CommandQueue4Xi                                                                 
from bpu2commandqueue4xi import BPU2CommandQueue4Xi
from cpu2commandqueue4xi import CPU2CommandQueue4Xi
from dpu2commandqueue4xi import DPU2CommandQueue4Xi
from epu2commandqueue4xi import EPU2CommandQueue4Xi
from fpu2commandqueue4xi import FPU2CommandQueue4Xi
from gpu2commandqueue4xi import GPU2CommandQueue4Xi
from hpu2commandqueue4xi import HPU2CommandQueue4Xi
from ipu2commandqueue4xi import IPU2CommandQueue4Xi
from jpu2commandqueue4xi import JPU2CommandQueue4Xi
from kpu2commandqueue4xi import KPU2CommandQueue4Xi
from lpu2commandqueue4xi import LPU2CommandQueue4Xi
from mpu2commandqueue4xi import MPU2CommandQueue4Xi
from npu2commandqueue4xi import NPU2CommandQueue4Xi
from opu2commandqueue4xi import OPU2CommandQueue4Xi
from ppu2commandqueue4xi import PPU2CommandQueue4Xi
from qpu2commandqueue4xi import QPU2CommandQueue4Xi
from rpu2commandqueue4xi import RPU2CommandQueue4Xi
from spu2commandqueue4xi import SPU2CommandQueue4Xi
from tpu2commandqueue4xi import TPU2CommandQueue4Xi
from upu2commandqueue4xi import UPU2CommandQueue4Xi
from vpu2commandqueue4xi import VPU2CommandQueue4Xi
from xpu2commandqueue4xi import XPU2CommandQueue4Xi
from wpu2commandqueue4xi import WPU2CommandQueue4Xi
from ypu2commandqueue4xi import YPU2CommandQueue4Xi
from zpu2commandqueue4xi import ZPU2CommandQueue4Xi

from apu2commandqueue4xi import create2commandqueue4apu 
from bpu2commandqueue4xi import create2commandqueue4bpu 
from cpu2commandqueue4xi import create2commandqueue4cpu 
from dpu2commandqueue4xi import create2commandqueue4dpu 
from epu2commandqueue4xi import create2commandqueue4epu 
from fpu2commandqueue4xi import create2commandqueue4fpu 
from gpu2commandqueue4xi import create2commandqueue4gpu 
from hpu2commandqueue4xi import create2commandqueue4hpu 
from ipu2commandqueue4xi import create2commandqueue4ipu 
from jpu2commandqueue4xi import create2commandqueue4jpu 
from kpu2commandqueue4xi import create2commandqueue4kpu 
from lpu2commandqueue4xi import create2commandqueue4lpu 
from mpu2commandqueue4xi import create2commandqueue4mpu 
from npu2commandqueue4xi import create2commandqueue4npu 
from opu2commandqueue4xi import create2commandqueue4opu 
from ppu2commandqueue4xi import create2commandqueue4ppu 
from qpu2commandqueue4xi import create2commandqueue4qpu 
from rpu2commandqueue4xi import create2commandqueue4rpu 
from spu2commandqueue4xi import create2commandqueue4spu 
from tpu2commandqueue4xi import create2commandqueue4tpu 
from upu2commandqueue4xi import create2commandqueue4upu 
from vpu2commandqueue4xi import create2commandqueue4vpu 
from xpu2commandqueue4xi import create2commandqueue4xpu 
from wpu2commandqueue4xi import create2commandqueue4wpu 
from ypu2commandqueue4xi import create2commandqueue4ypu 
from zpu2commandqueue4xi import create2commandqueue4zpu 

from apu2commandqueue4xi import get2commandqueueinfo4apu
from bpu2commandqueue4xi import get2commandqueueinfo4bpu
from cpu2commandqueue4xi import get2commandqueueinfo4cpu
from dpu2commandqueue4xi import get2commandqueueinfo4dpu
from epu2commandqueue4xi import get2commandqueueinfo4epu
from fpu2commandqueue4xi import get2commandqueueinfo4fpu
from gpu2commandqueue4xi import get2commandqueueinfo4gpu
from hpu2commandqueue4xi import get2commandqueueinfo4hpu
from ipu2commandqueue4xi import get2commandqueueinfo4ipu
from jpu2commandqueue4xi import get2commandqueueinfo4jpu
from kpu2commandqueue4xi import get2commandqueueinfo4kpu
from lpu2commandqueue4xi import get2commandqueueinfo4lpu
from mpu2commandqueue4xi import get2commandqueueinfo4mpu
from npu2commandqueue4xi import get2commandqueueinfo4npu
from opu2commandqueue4xi import get2commandqueueinfo4opu
from ppu2commandqueue4xi import get2commandqueueinfo4ppu
from qpu2commandqueue4xi import get2commandqueueinfo4qpu
from rpu2commandqueue4xi import get2commandqueueinfo4rpu
from spu2commandqueue4xi import get2commandqueueinfo4spu
from tpu2commandqueue4xi import get2commandqueueinfo4tpu
from upu2commandqueue4xi import get2commandqueueinfo4upu
from vpu2commandqueue4xi import get2commandqueueinfo4vpu
from xpu2commandqueue4xi import get2commandqueueinfo4xpu
from wpu2commandqueue4xi import get2commandqueueinfo4wpu
from ypu2commandqueue4xi import get2commandqueueinfo4ypu
from zpu2commandqueue4xi import get2commandqueueinfo4zpu

from apu2commandqueue4xi import release2commandqueue4apu
from bpu2commandqueue4xi import release2commandqueue4bpu
from cpu2commandqueue4xi import release2commandqueue4cpu
from dpu2commandqueue4xi import release2commandqueue4dpu
from epu2commandqueue4xi import release2commandqueue4epu
from fpu2commandqueue4xi import release2commandqueue4fpu
from gpu2commandqueue4xi import release2commandqueue4gpu
from hpu2commandqueue4xi import release2commandqueue4hpu
from ipu2commandqueue4xi import release2commandqueue4ipu
from jpu2commandqueue4xi import release2commandqueue4jpu
from kpu2commandqueue4xi import release2commandqueue4kpu
from lpu2commandqueue4xi import release2commandqueue4lpu
from mpu2commandqueue4xi import release2commandqueue4mpu
from npu2commandqueue4xi import release2commandqueue4npu
from opu2commandqueue4xi import release2commandqueue4opu
from ppu2commandqueue4xi import release2commandqueue4ppu
from qpu2commandqueue4xi import release2commandqueue4qpu
from rpu2commandqueue4xi import release2commandqueue4rpu
from spu2commandqueue4xi import release2commandqueue4spu
from tpu2commandqueue4xi import release2commandqueue4tpu
from upu2commandqueue4xi import release2commandqueue4upu
from vpu2commandqueue4xi import release2commandqueue4vpu
from xpu2commandqueue4xi import release2commandqueue4xpu
from wpu2commandqueue4xi import release2commandqueue4wpu
from ypu2commandqueue4xi import release2commandqueue4ypu
from zpu2commandqueue4xi import release2commandqueue4zpu

from apu2commandqueue4xi import retain2commandqueue4apu
from bpu2commandqueue4xi import retain2commandqueue4bpu
from cpu2commandqueue4xi import retain2commandqueue4cpu
from dpu2commandqueue4xi import retain2commandqueue4dpu
from epu2commandqueue4xi import retain2commandqueue4epu
from fpu2commandqueue4xi import retain2commandqueue4fpu
from gpu2commandqueue4xi import retain2commandqueue4gpu
from hpu2commandqueue4xi import retain2commandqueue4hpu
from ipu2commandqueue4xi import retain2commandqueue4ipu
from jpu2commandqueue4xi import retain2commandqueue4jpu
from kpu2commandqueue4xi import retain2commandqueue4kpu
from lpu2commandqueue4xi import retain2commandqueue4lpu
from mpu2commandqueue4xi import retain2commandqueue4mpu
from npu2commandqueue4xi import retain2commandqueue4npu
from opu2commandqueue4xi import retain2commandqueue4opu
from ppu2commandqueue4xi import retain2commandqueue4ppu
from qpu2commandqueue4xi import retain2commandqueue4qpu
from rpu2commandqueue4xi import retain2commandqueue4rpu
from spu2commandqueue4xi import retain2commandqueue4spu
from tpu2commandqueue4xi import retain2commandqueue4tpu
from upu2commandqueue4xi import retain2commandqueue4upu
from vpu2commandqueue4xi import retain2commandqueue4vpu
from xpu2commandqueue4xi import retain2commandqueue4xpu
from wpu2commandqueue4xi import retain2commandqueue4wpu
from ypu2commandqueue4xi import retain2commandqueue4ypu
from zpu2commandqueue4xi import retain2commandqueue4zpu

from apu2commandqueue4xi import set2commandqueue4apu
from bpu2commandqueue4xi import set2commandqueue4bpu
from cpu2commandqueue4xi import set2commandqueue4cpu
from dpu2commandqueue4xi import set2commandqueue4dpu
from epu2commandqueue4xi import set2commandqueue4epu
from fpu2commandqueue4xi import set2commandqueue4fpu
from gpu2commandqueue4xi import set2commandqueue4gpu
from hpu2commandqueue4xi import set2commandqueue4hpu
from ipu2commandqueue4xi import set2commandqueue4ipu
from jpu2commandqueue4xi import set2commandqueue4jpu
from kpu2commandqueue4xi import set2commandqueue4kpu
from lpu2commandqueue4xi import set2commandqueue4lpu
from mpu2commandqueue4xi import set2commandqueue4mpu
from npu2commandqueue4xi import set2commandqueue4npu
from opu2commandqueue4xi import set2commandqueue4opu
from ppu2commandqueue4xi import set2commandqueue4ppu
from qpu2commandqueue4xi import set2commandqueue4qpu
from rpu2commandqueue4xi import set2commandqueue4rpu
from spu2commandqueue4xi import set2commandqueue4spu
from tpu2commandqueue4xi import set2commandqueue4tpu
from upu2commandqueue4xi import set2commandqueue4upu
from vpu2commandqueue4xi import set2commandqueue4vpu
from xpu2commandqueue4xi import set2commandqueue4xpu
from wpu2commandqueue4xi import set2commandqueue4wpu
from ypu2commandqueue4xi import set2commandqueue4ypu
from zpu2commandqueue4xi import set2commandqueue4zpu

from apu2commandqueue4xi import trace2commandqueue4apu
from bpu2commandqueue4xi import trace2commandqueue4bpu
from cpu2commandqueue4xi import trace2commandqueue4cpu
from dpu2commandqueue4xi import trace2commandqueue4dpu
from epu2commandqueue4xi import trace2commandqueue4epu
from fpu2commandqueue4xi import trace2commandqueue4fpu
from gpu2commandqueue4xi import trace2commandqueue4gpu
from hpu2commandqueue4xi import trace2commandqueue4hpu
from ipu2commandqueue4xi import trace2commandqueue4ipu
from jpu2commandqueue4xi import trace2commandqueue4jpu
from kpu2commandqueue4xi import trace2commandqueue4kpu
from lpu2commandqueue4xi import trace2commandqueue4lpu
from mpu2commandqueue4xi import trace2commandqueue4mpu
from npu2commandqueue4xi import trace2commandqueue4npu
from opu2commandqueue4xi import trace2commandqueue4opu
from ppu2commandqueue4xi import trace2commandqueue4ppu
from qpu2commandqueue4xi import trace2commandqueue4qpu
from rpu2commandqueue4xi import trace2commandqueue4rpu
from spu2commandqueue4xi import trace2commandqueue4spu
from tpu2commandqueue4xi import trace2commandqueue4tpu
from upu2commandqueue4xi import trace2commandqueue4upu
from vpu2commandqueue4xi import trace2commandqueue4vpu
from xpu2commandqueue4xi import trace2commandqueue4xpu
from wpu2commandqueue4xi import trace2commandqueue4wpu
from ypu2commandqueue4xi import trace2commandqueue4ypu
from zpu2commandqueue4xi import trace2commandqueue4zpu


# -------------------------------------------------------------------------------------------------
# Context modules                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi                                                                                 
from context4xi import create2context4xi                                                                         
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi                                                                             
from context4xi import get2context4xi         

from apu2context4xi import APU2Context4Xi                                                                           
from bpu2context4xi import BPU2Context4Xi
from cpu2context4xi import CPU2Context4Xi
from dpu2context4xi import DPU2Context4Xi
from epu2context4xi import EPU2Context4Xi
from fpu2context4xi import FPU2Context4Xi
from gpu2context4xi import GPU2Context4Xi
from hpu2context4xi import HPU2Context4Xi
from ipu2context4xi import IPU2Context4Xi
from jpu2context4xi import JPU2Context4Xi
from kpu2context4xi import KPU2Context4Xi
from lpu2context4xi import LPU2Context4Xi
from mpu2context4xi import MPU2Context4Xi
from npu2context4xi import NPU2Context4Xi
from opu2context4xi import OPU2Context4Xi
from ppu2context4xi import PPU2Context4Xi
from qpu2context4xi import QPU2Context4Xi
from rpu2context4xi import RPU2Context4Xi
from spu2context4xi import SPU2Context4Xi
from tpu2context4xi import TPU2Context4Xi
from upu2context4xi import UPU2Context4Xi
from vpu2context4xi import VPU2Context4Xi
from xpu2context4xi import XPU2Context4Xi
from wpu2context4xi import WPU2Context4Xi
from ypu2context4xi import YPU2Context4Xi
from zpu2context4xi import ZPU2Context4Xi

from apu2context4xi import create2context4apu 
from bpu2context4xi import create2context4bpu 
from cpu2context4xi import create2context4cpu 
from dpu2context4xi import create2context4dpu 
from epu2context4xi import create2context4epu 
from fpu2context4xi import create2context4fpu 
from gpu2context4xi import create2context4gpu 
from hpu2context4xi import create2context4hpu 
from ipu2context4xi import create2context4ipu 
from jpu2context4xi import create2context4jpu 
from kpu2context4xi import create2context4kpu 
from lpu2context4xi import create2context4lpu 
from mpu2context4xi import create2context4mpu 
from npu2context4xi import create2context4npu 
from opu2context4xi import create2context4opu 
from ppu2context4xi import create2context4ppu 
from qpu2context4xi import create2context4qpu 
from rpu2context4xi import create2context4rpu 
from spu2context4xi import create2context4spu 
from tpu2context4xi import create2context4tpu 
from upu2context4xi import create2context4upu 
from vpu2context4xi import create2context4vpu 
from xpu2context4xi import create2context4xpu 
from wpu2context4xi import create2context4wpu 
from ypu2context4xi import create2context4ypu 
from zpu2context4xi import create2context4zpu 


from apu2context4xi import get2context4apu
from bpu2context4xi import get2context4bpu
from cpu2context4xi import get2context4cpu
from dpu2context4xi import get2context4dpu
from epu2context4xi import get2context4epu
from fpu2context4xi import get2context4fpu
from gpu2context4xi import get2context4gpu
from hpu2context4xi import get2context4hpu
from ipu2context4xi import get2context4ipu
from jpu2context4xi import get2context4jpu
from kpu2context4xi import get2context4kpu
from lpu2context4xi import get2context4lpu
from mpu2context4xi import get2context4mpu
from npu2context4xi import get2context4npu
from opu2context4xi import get2context4opu
from ppu2context4xi import get2context4ppu
from qpu2context4xi import get2context4qpu
from rpu2context4xi import get2context4rpu
from spu2context4xi import get2context4spu
from tpu2context4xi import get2context4tpu
from upu2context4xi import get2context4upu
from vpu2context4xi import get2context4vpu
from xpu2context4xi import get2context4xpu
from wpu2context4xi import get2context4wpu
from ypu2context4xi import get2context4ypu
from zpu2context4xi import get2context4zpu

from apu2context4xi import release2context4apu
from bpu2context4xi import release2context4bpu
from cpu2context4xi import release2context4cpu
from dpu2context4xi import release2context4dpu
from epu2context4xi import release2context4epu
from fpu2context4xi import release2context4fpu
from gpu2context4xi import release2context4gpu
from hpu2context4xi import release2context4hpu
from ipu2context4xi import release2context4ipu
from jpu2context4xi import release2context4jpu
from kpu2context4xi import release2context4kpu
from lpu2context4xi import release2context4lpu
from mpu2context4xi import release2context4mpu
from npu2context4xi import release2context4npu
from opu2context4xi import release2context4opu
from ppu2context4xi import release2context4ppu
from qpu2context4xi import release2context4qpu
from rpu2context4xi import release2context4rpu
from spu2context4xi import release2context4spu
from tpu2context4xi import release2context4tpu
from upu2context4xi import release2context4upu
from vpu2context4xi import release2context4vpu
from xpu2context4xi import release2context4xpu
from wpu2context4xi import release2context4wpu
from ypu2context4xi import release2context4ypu
from zpu2context4xi import release2context4zpu

from apu2context4xi import retain2context4apu
from bpu2context4xi import retain2context4bpu
from cpu2context4xi import retain2context4cpu
from dpu2context4xi import retain2context4dpu
from epu2context4xi import retain2context4epu
from fpu2context4xi import retain2context4fpu
from gpu2context4xi import retain2context4gpu
from hpu2context4xi import retain2context4hpu
from ipu2context4xi import retain2context4ipu
from jpu2context4xi import retain2context4jpu
from kpu2context4xi import retain2context4kpu
from lpu2context4xi import retain2context4lpu
from mpu2context4xi import retain2context4mpu
from npu2context4xi import retain2context4npu
from opu2context4xi import retain2context4opu
from ppu2context4xi import retain2context4ppu
from qpu2context4xi import retain2context4qpu
from rpu2context4xi import retain2context4rpu
from spu2context4xi import retain2context4spu
from tpu2context4xi import retain2context4tpu
from upu2context4xi import retain2context4upu
from vpu2context4xi import retain2context4vpu
from xpu2context4xi import retain2context4xpu
from wpu2context4xi import retain2context4wpu
from ypu2context4xi import retain2context4ypu
from zpu2context4xi import retain2context4zpu

from apu2context4xi import set2context4apu
from bpu2context4xi import set2context4bpu
from cpu2context4xi import set2context4cpu
from dpu2context4xi import set2context4dpu
from epu2context4xi import set2context4epu
from fpu2context4xi import set2context4fpu
from gpu2context4xi import set2context4gpu
from hpu2context4xi import set2context4hpu
from ipu2context4xi import set2context4ipu
from jpu2context4xi import set2context4jpu
from kpu2context4xi import set2context4kpu
from lpu2context4xi import set2context4lpu
from mpu2context4xi import set2context4mpu
from npu2context4xi import set2context4npu
from opu2context4xi import set2context4opu
from ppu2context4xi import set2context4ppu
from qpu2context4xi import set2context4qpu
from rpu2context4xi import set2context4rpu
from spu2context4xi import set2context4spu
from tpu2context4xi import set2context4tpu
from upu2context4xi import set2context4upu
from vpu2context4xi import set2context4vpu
from xpu2context4xi import set2context4xpu
from wpu2context4xi import set2context4wpu
from ypu2context4xi import set2context4ypu
from zpu2context4xi import set2context4zpu


# -------------------------------------------------------------------------------------------------
# Device modules                           
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi                                                                                   
from device4xi import init2device4xi                                                                              
from device4xi import set2device4xi                                                                               
from device4xi import get2device4xi                                                                               

from apu2device4xi import APU4Xi                                                                                   
from bpu2device4xi import BPU4Xi
from cpu2device4xi import CPU4Xi
from dpu2device4xi import DPU4Xi
from epu2device4xi import EPU4Xi
from fpu2device4xi import FPU4Xi
from gpu2device4xi import GPU4Xi
from hpu2device4xi import HPU4Xi
from ipu2device4xi import IPU4Xi
from jpu2device4xi import JPU4Xi
from kpu2device4xi import KPU4Xi
from lpu2device4xi import LPU4Xi
from mpu2device4xi import MPU4Xi
from npu2device4xi import NPU4Xi
from opu2device4xi import OPU4Xi
from ppu2device4xi import PPU4Xi
from qpu2device4xi import QPU4Xi
from rpu2device4xi import RPU4Xi
from spu2device4xi import SPU4Xi
from tpu2device4xi import TPU4Xi
from upu2device4xi import UPU4Xi
from vpu2device4xi import VPU4Xi
from xpu2device4xi import XPU4Xi
from wpu2device4xi import WPU4Xi
from ypu2device4xi import YPU4Xi
from zpu2device4xi import ZPU4Xi

from apu2device4xi import init2apu4xi 
from bpu2device4xi import init2bpu4xi 
from cpu2device4xi import init2cpu4xi 
from dpu2device4xi import init2dpu4xi 
from epu2device4xi import init2epu4xi 
from fpu2device4xi import init2fpu4xi 
from gpu2device4xi import init2gpu4xi 
from hpu2device4xi import init2hpu4xi 
from ipu2device4xi import init2ipu4xi 
from jpu2device4xi import init2jpu4xi 
from kpu2device4xi import init2kpu4xi 
from lpu2device4xi import init2lpu4xi 
from mpu2device4xi import init2mpu4xi 
from npu2device4xi import init2npu4xi 
from opu2device4xi import init2opu4xi 
from ppu2device4xi import init2ppu4xi 
from qpu2device4xi import init2qpu4xi 
from rpu2device4xi import init2rpu4xi 
from spu2device4xi import init2spu4xi 
from tpu2device4xi import init2tpu4xi 
from upu2device4xi import init2upu4xi 
from vpu2device4xi import init2vpu4xi 
from xpu2device4xi import init2xpu4xi 
from wpu2device4xi import init2wpu4xi 
from ypu2device4xi import init2ypu4xi 
from zpu2device4xi import init2zpu4xi 

from apu2device4xi import set2apu4xi
from bpu2device4xi import set2bpu4xi
from cpu2device4xi import set2cpu4xi
from dpu2device4xi import set2dpu4xi
from epu2device4xi import set2epu4xi
from fpu2device4xi import set2fpu4xi
from gpu2device4xi import set2gpu4xi
from hpu2device4xi import set2hpu4xi
from ipu2device4xi import set2ipu4xi
from jpu2device4xi import set2jpu4xi
from kpu2device4xi import set2kpu4xi
from lpu2device4xi import set2lpu4xi
from mpu2device4xi import set2mpu4xi
from npu2device4xi import set2npu4xi
from opu2device4xi import set2opu4xi
from ppu2device4xi import set2ppu4xi
from qpu2device4xi import set2qpu4xi
from rpu2device4xi import set2rpu4xi
from spu2device4xi import set2spu4xi
from tpu2device4xi import set2tpu4xi
from upu2device4xi import set2upu4xi
from vpu2device4xi import set2vpu4xi
from xpu2device4xi import set2xpu4xi
from wpu2device4xi import set2wpu4xi
from ypu2device4xi import set2ypu4xi
from zpu2device4xi import set2zpu4xi

from apu2device4xi import get2apu4xi
from bpu2device4xi import get2bpu4xi
from cpu2device4xi import get2cpu4xi
from dpu2device4xi import get2dpu4xi
from epu2device4xi import get2epu4xi
from fpu2device4xi import get2fpu4xi
from gpu2device4xi import get2gpu4xi
from hpu2device4xi import get2hpu4xi
from ipu2device4xi import get2ipu4xi
from jpu2device4xi import get2jpu4xi
from kpu2device4xi import get2kpu4xi
from lpu2device4xi import get2lpu4xi
from mpu2device4xi import get2mpu4xi
from npu2device4xi import get2npu4xi
from opu2device4xi import get2opu4xi
from ppu2device4xi import get2ppu4xi
from qpu2device4xi import get2qpu4xi
from rpu2device4xi import get2rpu4xi
from spu2device4xi import get2spu4xi
from tpu2device4xi import get2tpu4xi
from upu2device4xi import get2upu4xi
from vpu2device4xi import get2vpu4xi
from xpu2device4xi import get2xpu4xi
from wpu2device4xi import get2wpu4xi
from ypu2device4xi import get2ypu4xi
from zpu2device4xi import get2zpu4xi


# -------------------------------------------------------------------------------------------------
# Platform                           
# -------------------------------------------------------------------------------------------------
from platformids4xi import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi


                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global trace2scope 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                trace2scope.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            trace2scope.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global trace2scope
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Event4Xi': 'NACK4TRACE',
         'create2event4xi': 'NACK4TRACE',
         'get2eventinfo4xi': 'NACK4TRACE',
         'release2event4xi': 'NACK4TRACE',
         'retain2event4xi': 'NACK4TRACE',
         'set2event4xi': 'NACK4TRACE',
         'set2eventcallback4xi': 'NACK4TRACE',
         'trace2event4xi': 'NACK4TRACE',
         'wait2event4xi': 'NACK4TRACE'          
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        trace2scope.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>                  

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace for event4xi test
#"> 

# -------------------------------------------------------------------------------------------------    
def print2trace4xi(trace2scope):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-event4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Event in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Event sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(trace2scope, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-event4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Event in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(trace2scope, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-event4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Event in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Event.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(trace2scope, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "event4xi5test" usage = "
# tests event4xi
#"> 

# -------------------------------------------------------------------------------------------------    
def event4xi5test():

    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 1A/33) OF EVENT4XI5TEST - STARTED ', time4xi()) 
    print('=' *33)   
    # 
    
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS                          
    # ---------------------------------------------------------------------------------------------
    
              
    # ---------------------------------------------------------------------------------------------
    # CREATE EVENT WITH FUNCTION                   
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) OF EVENT4XI5TEST - TRYING TO CREATE EVENT4XI ', time4xi())     
    print('=' *33)        
    #  
    
    try:
        cq2xi = create2event4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
        print('(Step 2B/33) OF EVENT4XI5TEST - CREATED EVENT4XI: ', cq2xi)                                   

        #  {'DPU': {'CODE2ERROR': 0, 
        #           'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 
        #           'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 
        #           'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 
        #           'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004C90C18>, 
        #           'NACK2RETURN': ' ', 
        #           'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003AE8248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004D22CF8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 612>, <read-write PipeConnection, handle 616>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 580>, <read-write PipeConnection, handle 584>)}, 
        #   'EPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4epu', 'METHOD': 'create2event4epu'}, 'FUNCTION2CALLBACK': <function trace2event4epu at 0x0000000003C2D848>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004D53668>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B09648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4epu', 'METHOD': 'create2commandqueue4epu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4epu at 0x0000000003C2D0C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004E5F4A8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B09648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 676>, <read-write PipeConnection, handle 680>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 644>, <read-write PipeConnection, handle 648>)}, 
        #   'BPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4bpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4bpu', 'METHOD': 'create2event4bpu'}, 'FUNCTION2CALLBACK': <function trace2event4bpu at 0x0000000003C767C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004948F60>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4bpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4bpu', 'METHOD': 'create2context4bpu'}, 'FUNCTION2CALLBACK': <function trace2context4bpu at 0x0000000004008AC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4bpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4bpu', 'METHOD': 'create2commandqueue4bpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4bpu at 0x0000000003C96F48>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004A51710>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4bpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4bpu', 'METHOD': 'create2context4bpu'}, 'FUNCTION2CALLBACK': <function trace2context4bpu at 0x0000000004008AC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_BPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 484>, <read-write PipeConnection, handle 488>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_BPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 452>, <read-write PipeConnection, handle 456>)}, 
        #   'CPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4cpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4cpu', 'METHOD': 'create2event4cpu'}, 'FUNCTION2CALLBACK': <function trace2event4cpu at 0x0000000003F92B48>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004AF3860>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003F00948>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4cpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4cpu', 'METHOD': 'create2commandqueue4cpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4cpu at 0x0000000003F923C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004C0C940>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003F00948>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4017, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 548>, <read-write PipeConnection, handle 552>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4017, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 516>, <read-write PipeConnection, handle 520>)}, 
        #   'VPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4vpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4vpu', 'METHOD': 'create2event4vpu'}, 'FUNCTION2CALLBACK': <function trace2event4vpu at 0x00000000043D4DC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005D6A128>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000004384BC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4vpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4vpu', 'METHOD': 'create2commandqueue4vpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4vpu at 0x00000000043D4648>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005E21208>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000004384BC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4005, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1768>, <read-write PipeConnection, handle 1772>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4005, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1736>, <read-write PipeConnection, handle 1740>)}, 
        #   'RPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4rpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4rpu', 'METHOD': 'create2event4rpu'}, 'FUNCTION2CALLBACK': <function trace2event4rpu at 0x0000000004223448>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005A89D68>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4rpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4rpu', 'METHOD': 'create2context4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000004167248>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4rpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4rpu', 'METHOD': 'create2commandqueue4rpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4rpu at 0x000000000420CC48>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005B0BE48>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4rpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4rpu', 'METHOD': 'create2context4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000004167248>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_RPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1512>, <read-write PipeConnection, handle 1516>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_RPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1480>, <read-write PipeConnection, handle 1484>)}, 
        #   'WPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4wpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4wpu', 'METHOD': 'create2event4wpu'}, 'FUNCTION2CALLBACK': <function trace2event4wpu at 0x00000000044AFAC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005F7D7F0>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4wpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4wpu', 'METHOD': 'create2context4wpu'}, 'FUNCTION2CALLBACK': <function trace2context4wpu at 0x00000000044648C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4wpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4wpu', 'METHOD': 'create2commandqueue4wpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4wpu at 0x00000000044AF348>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FC8048>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4wpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4wpu', 'METHOD': 'create2context4wpu'}, 'FUNCTION2CALLBACK': <function trace2context4wpu at 0x00000000044648C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_WPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1896>, <read-write PipeConnection, handle 1900>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_WPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1864>, <read-write PipeConnection, handle 1868>)}, 
        #   'SPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4spu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4spu', 'METHOD': 'create2event4spu'}, 'FUNCTION2CALLBACK': <function trace2event4spu at 0x000000000427B2C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005B69160>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4spu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4spu', 'METHOD': 'create2context4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x00000000042440C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4spu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4spu', 'METHOD': 'create2commandqueue4spu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4spu at 0x0000000004265AC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004EF1240>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4spu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4spu', 'METHOD': 'create2context4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x00000000042440C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4012, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_SPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1576>, <read-write PipeConnection, handle 1580>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4012, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_SPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1544>, <read-write PipeConnection, handle 1548>)}, 
        #   'PPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4ppu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4ppu', 'METHOD': 'create2event4ppu'}, 'FUNCTION2CALLBACK': <function trace2event4ppu at 0x0000000003E8B748>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000058AD3C8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4ppu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4ppu', 'METHOD': 'create2context4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x0000000003E3B548>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4ppu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4ppu', 'METHOD': 'create2commandqueue4ppu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4ppu at 0x0000000003E71F48>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000058DD4A8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4ppu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4ppu', 'METHOD': 'create2context4ppu'}, 'FUNCTION2CALLBACK': <function trace2context4ppu at 0x0000000003E3B548>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_PPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1384>, <read-write PipeConnection, handle 1388>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_PPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1352>, <read-write PipeConnection, handle 1356>)},
        #   'QPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4qpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4qpu', 'METHOD': 'create2event4qpu'}, 'FUNCTION2CALLBACK': <function trace2event4qpu at 0x00000000041485C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000596BDD8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x00000000040FA3C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4qpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4qpu', 'METHOD': 'create2commandqueue4qpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4qpu at 0x0000000004122DC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000059FEC18>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4qpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4qpu', 'METHOD': 'create2context4qpu'}, 'FUNCTION2CALLBACK': <function trace2context4qpu at 0x00000000040FA3C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1448>, <read-write PipeConnection, handle 1452>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_QPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1416>, <read-write PipeConnection, handle 1420>)}, 
        #   'KPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4kpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4kpu', 'METHOD': 'create2event4kpu'}, 'FUNCTION2CALLBACK': <function trace2event4kpu at 0x0000000003BA0EC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000053C52E8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4kpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4kpu', 'METHOD': 'create2context4kpu'}, 'FUNCTION2CALLBACK': <function trace2context4kpu at 0x0000000003B53CC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4kpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4kpu', 'METHOD': 'create2commandqueue4kpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4kpu at 0x0000000003BA0748>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005490A58>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4kpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4kpu', 'METHOD': 'create2context4kpu'}, 'FUNCTION2CALLBACK': <function trace2context4kpu at 0x0000000003B53CC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_KPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1064>, <read-write PipeConnection, handle 1068>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_KPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1032>, <read-write PipeConnection, handle 1036>)}, 
        #   'YPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4ypu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4ypu', 'METHOD': 'create2event4ypu'}, 'FUNCTION2CALLBACK': <function trace2event4ypu at 0x000000000451D948>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005FE8DD8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4ypu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4ypu', 'METHOD': 'create2context4ypu'}, 'FUNCTION2CALLBACK': <function trace2context4ypu at 0x00000000044D9748>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4ypu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4ypu', 'METHOD': 'create2commandqueue4ypu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4ypu at 0x000000000451D1C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006100588>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4ypu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4ypu', 'METHOD': 'create2context4ypu'}, 'FUNCTION2CALLBACK': <function trace2context4ypu at 0x00000000044D9748>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_YPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1960>, <read-write PipeConnection, handle 1964>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_YPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1928>, <read-write PipeConnection, handle 1932>)}, 
        #   'LPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4lpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4lpu', 'METHOD': 'create2event4lpu'}, 'FUNCTION2CALLBACK': <function trace2event4lpu at 0x000000000325DD48>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000054D58D0>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x0000000003BBDB48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4lpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4lpu', 'METHOD': 'create2commandqueue4lpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4lpu at 0x000000000325D5C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000558E080>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4lpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4lpu', 'METHOD': 'create2context4lpu'}, 'FUNCTION2CALLBACK': <function trace2context4lpu at 0x0000000003BBDB48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1128>, <read-write PipeConnection, handle 1132>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_LPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1096>, <read-write PipeConnection, handle 1100>)}, 
        #   'ZPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4zpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4zpu', 'METHOD': 'create2event4zpu'}, 'FUNCTION2CALLBACK': <function trace2event4zpu at 0x000000000458A7C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000006121400>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x00000000045355C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4zpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4zpu', 'METHOD': 'create2commandqueue4zpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4zpu at 0x000000000458A048>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000061DDB70>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 04:19:53 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x00000000045355C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_ZPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 2024>, <read-write PipeConnection, handle 2028>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_ZPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1992>, <read-write PipeConnection, handle 1996>)}, 
        #   'HPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4hpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4hpu', 'METHOD': 'create2event4hpu'}, 'FUNCTION2CALLBACK': <function trace2event4hpu at 0x0000000003F573C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000005119A90>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4hpu', 'METHOD': 'create2context4hpu'}, 'FUNCTION2CALLBACK': <function trace2context4hpu at 0x0000000003ECE1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4hpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4hpu', 'METHOD': 'create2commandqueue4hpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4hpu at 0x0000000003F42BC8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000051E0860>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4hpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4hpu', 'METHOD': 'create2context4hpu'}, 'FUNCTION2CALLBACK': <function trace2context4hpu at 0x0000000003ECE1C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 868>, <read-write PipeConnection, handle 872>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_HPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 836>, <read-write PipeConnection, handle 840>)}, 
        #   ...
    except:
        print('(Step 2Z/33) OF EVENT4XI5TEST *** FAILED TO CREATE EVENT4XI', time4xi()) 
    
    # ---------------------------------------------------------------------------------------------
    # GET EVENT INFO WITH FUNCTION FROM THE CREATED EVENT KNOWLEDGEBASE OF ALL DEVICES                   
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) OF EVENT4XI5TEST - TRYING TO GET EVENTINFO4XI', time4xi())  
    print('=' *33)    
    try:
        cqinfo2xi = get2eventinfo4xi()                                                                       # AFTER SYSTEM CREATED  
        print('(Step 3B/33) OF EVENT4XI5TEST - GOT EVENTINFO4XI: ', cqinfo2xi)  
        # {'DPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004C90C18>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003AE8248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004D22CF8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 612>, <read-write PipeConnection, handle 616>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 580>, <read-write PipeConnection, handle 584>)}, 
        #  'EPU': {'CODE2ERROR': 0, 
        #          'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4epu', 'METHOD': 'create2event4epu'}, 
        #          'FUNCTION2CALLBACK': <function trace2event4epu at 0x0000000003C2D848>, 
        #          'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 
        #          'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004D53668>, 
        #          'NACK2RETURN': ' ', 
        #          'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B09648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4epu', 'METHOD': 'create2commandqueue4epu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4epu at 0x0000000003C2D0C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000004E5F4A8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B09648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 676>, <read-write PipeConnection, handle 680>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 644>, <read-write PipeConnection, handle 648>)}, 
     
    except:
        print('(Step 3Z/33) OF EVENT4XI5TEST *** FAILED TO GET EVENT4XI', time4xi())
            
    
    # ---------------------------------------------------------------------------------------------
    # SET EVENT WITH FUNCTION - ALL ATTRIBUTES TO EVENT KNOWLEDGEBASE OF ALL DEVICE                      
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4A/33) OF EVENT4XI5TEST - TRYING TO SET EVENT WITH FUNCTION ', time4xi())    
    print('=' *33)
    
    # ---------------------------------------------------------------------------------------------
    # (1) GET PLATFORM IDs - TO SET CONTEXT FOR EVENT KNOWLEDGEBASE OF ALL DEVICES
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4B/33) OF EVENT4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
    print('=' *33)    
    platform2xi = {}
    try:
        platform2xi = get2platformids4xi()
        print('(Step 4B/33) OF EVENT4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
        # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
        
    except:
        print('(Step 4Z/33) OF EVENT4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     

    # ---------------------------------------------------------------------------------------------
    # (2) INITIALIZE ALL DEVICES - TO SET CONTEXT FOR EVENT KNOWLEDGEBASE OF ALL DEVICES                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) OF EVENT4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
    print('=' *33)        
    try:
        device2xi = init2device4xi()                                                                                # NO PARAMETERS - THE SYSTEM SHOULD INITIALIZE ALL   
        print('(Step 2B/33) OF EVENT4XI5TEST - INITIALIZED DEVICE4XI TO: ', device2xi) 
        
    except:
        print('(Step 2Z/33) OF EVENT4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi()) 
            
         
    # ---------------------------------------------------------------------------------------------
    # (3) CREATE SYSTEM CONTEXT - TO SET CONTEXT FOR EVENT KNOWLEDGEBASE OF ALL DEVICES                   
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) OF EVENT4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
    print('=' *33)        
    try:
        context2xi = create2context4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
        print('(Step 3B/33) OF EVENT4XI5TEST - CREATED CONTEXT4XI: ', context2xi)                                  
        # 
        
    except:
        print('(Step 3Z/33) OF EVENT4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
     

          
    # ---------------------------------------------------------------------------------------------
    # (4) TASK DICTIONARY FOR ALL DEVICES                            
    # ---------------------------------------------------------------------------------------------            
    task4set2event = {}
    task4set2event ['APU'] = {}
    task4set2event ['BPU'] = {}
    task4set2event ['CPU'] = {}
    task4set2event ['DPU'] = {}
    task4set2event ['EPU'] = {}
    task4set2event ['FPU'] = {}
    task4set2event ['GPU'] = {}
    task4set2event ['HPU'] = {}
    task4set2event ['IPU'] = {}
    task4set2event ['JPU'] = {}
    task4set2event ['KPU'] = {}
    task4set2event ['LPU'] = {}
    task4set2event ['MPU'] = {}
    task4set2event ['NPU'] = {}
    task4set2event ['OPU'] = {}
    task4set2event ['PPU'] = {}
    task4set2event ['QPU'] = {}
    task4set2event ['RPU'] = {}
    task4set2event ['SPU'] = {}
    task4set2event ['TPU'] = {}
    task4set2event ['UPU'] = {}
    task4set2event ['VPU'] = {}
    task4set2event ['XPU'] = {}
    task4set2event ['WPU'] = {}
    task4set2event ['YPU'] = {}
    task4set2event ['ZPU'] = {}
    
    # ---------------------------------------------------------------------------------------------
    # (5) CONTEXT TO TASK - REQUIRED                                
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['CONTEXT'] = context2xi ['APU'] 
    task4set2event ['BPU'] ['CONTEXT'] = context2xi ['BPU'] 
    task4set2event ['CPU'] ['CONTEXT'] = context2xi ['CPU'] 
    task4set2event ['DPU'] ['CONTEXT'] = context2xi ['DPU'] 
    task4set2event ['EPU'] ['CONTEXT'] = context2xi ['EPU'] 
    task4set2event ['FPU'] ['CONTEXT'] = context2xi ['FPU'] 
    task4set2event ['GPU'] ['CONTEXT'] = context2xi ['GPU'] 
    task4set2event ['HPU'] ['CONTEXT'] = context2xi ['HPU'] 
    task4set2event ['IPU'] ['CONTEXT'] = context2xi ['IPU'] 
    task4set2event ['JPU'] ['CONTEXT'] = context2xi ['JPU'] 
    task4set2event ['KPU'] ['CONTEXT'] = context2xi ['KPU'] 
    task4set2event ['LPU'] ['CONTEXT'] = context2xi ['LPU'] 
    task4set2event ['MPU'] ['CONTEXT'] = context2xi ['MPU'] 
    task4set2event ['NPU'] ['CONTEXT'] = context2xi ['NPU'] 
    task4set2event ['OPU'] ['CONTEXT'] = context2xi ['OPU'] 
    task4set2event ['PPU'] ['CONTEXT'] = context2xi ['PPU'] 
    task4set2event ['QPU'] ['CONTEXT'] = context2xi ['QPU'] 
    task4set2event ['RPU'] ['CONTEXT'] = context2xi ['RPU'] 
    task4set2event ['SPU'] ['CONTEXT'] = context2xi ['SPU'] 
    task4set2event ['TPU'] ['CONTEXT'] = context2xi ['TPU'] 
    task4set2event ['UPU'] ['CONTEXT'] = context2xi ['UPU'] 
    task4set2event ['VPU'] ['CONTEXT'] = context2xi ['VPU'] 
    task4set2event ['XPU'] ['CONTEXT'] = context2xi ['XPU'] 
    task4set2event ['WPU'] ['CONTEXT'] = context2xi ['WPU'] 
    task4set2event ['YPU'] ['CONTEXT'] = context2xi ['YPU'] 
    task4set2event ['ZPU'] ['CONTEXT'] = context2xi ['ZPU']                            
    
    # ---------------------------------------------------------------------------------------------
    # (6) DEVICES FOR TASK - EXTRA                        
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['DEVICE']  = device2xi ['APU'] 
    task4set2event ['BPU'] ['DEVICE']  = device2xi ['BPU'] 
    task4set2event ['CPU'] ['DEVICE']  = device2xi ['CPU'] 
    task4set2event ['DPU'] ['DEVICE']  = device2xi ['DPU'] 
    task4set2event ['EPU'] ['DEVICE']  = device2xi ['EPU'] 
    task4set2event ['FPU'] ['DEVICE']  = device2xi ['FPU'] 
    task4set2event ['GPU'] ['DEVICE']  = device2xi ['GPU'] 
    task4set2event ['HPU'] ['DEVICE']  = device2xi ['HPU'] 
    task4set2event ['IPU'] ['DEVICE']  = device2xi ['IPU'] 
    task4set2event ['JPU'] ['DEVICE']  = device2xi ['JPU'] 
    task4set2event ['KPU'] ['DEVICE']  = device2xi ['KPU'] 
    task4set2event ['LPU'] ['DEVICE']  = device2xi ['LPU'] 
    task4set2event ['MPU'] ['DEVICE']  = device2xi ['MPU'] 
    task4set2event ['NPU'] ['DEVICE']  = device2xi ['NPU'] 
    task4set2event ['OPU'] ['DEVICE']  = device2xi ['OPU'] 
    task4set2event ['PPU'] ['DEVICE']  = device2xi ['PPU'] 
    task4set2event ['QPU'] ['DEVICE']  = device2xi ['QPU'] 
    task4set2event ['RPU'] ['DEVICE']  = device2xi ['RPU'] 
    task4set2event ['SPU'] ['DEVICE']  = device2xi ['SPU'] 
    task4set2event ['TPU'] ['DEVICE']  = device2xi ['TPU'] 
    task4set2event ['UPU'] ['DEVICE']  = device2xi ['UPU'] 
    task4set2event ['VPU'] ['DEVICE']  = device2xi ['VPU'] 
    task4set2event ['XPU'] ['DEVICE']  = device2xi ['XPU'] 
    task4set2event ['WPU'] ['DEVICE']  = device2xi ['WPU'] 
    task4set2event ['YPU'] ['DEVICE']  = device2xi ['YPU'] 
    task4set2event ['ZPU'] ['DEVICE']  = device2xi ['ZPU']        
 
    # ---------------------------------------------------------------------------------------------
    # (7) PROPERTIES FOR TASK - NONE                          
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['PROPERTIES'] = None 
    task4set2event ['BPU'] ['PROPERTIES'] = None 
    task4set2event ['CPU'] ['PROPERTIES'] = None 
    task4set2event ['DPU'] ['PROPERTIES'] = None 
    task4set2event ['EPU'] ['PROPERTIES'] = None 
    task4set2event ['FPU'] ['PROPERTIES'] = None 
    task4set2event ['GPU'] ['PROPERTIES'] = None 
    task4set2event ['HPU'] ['PROPERTIES'] = None 
    task4set2event ['IPU'] ['PROPERTIES'] = None 
    task4set2event ['JPU'] ['PROPERTIES'] = None 
    task4set2event ['KPU'] ['PROPERTIES'] = None 
    task4set2event ['LPU'] ['PROPERTIES'] = None 
    task4set2event ['MPU'] ['PROPERTIES'] = None 
    task4set2event ['NPU'] ['PROPERTIES'] = None 
    task4set2event ['OPU'] ['PROPERTIES'] = None 
    task4set2event ['PPU'] ['PROPERTIES'] = None 
    task4set2event ['QPU'] ['PROPERTIES'] = None 
    task4set2event ['RPU'] ['PROPERTIES'] = None 
    task4set2event ['SPU'] ['PROPERTIES'] = None 
    task4set2event ['TPU'] ['PROPERTIES'] = None 
    task4set2event ['UPU'] ['PROPERTIES'] = None 
    task4set2event ['VPU'] ['PROPERTIES'] = None 
    task4set2event ['XPU'] ['PROPERTIES'] = None 
    task4set2event ['WPU'] ['PROPERTIES'] = None 
    task4set2event ['YPU'] ['PROPERTIES'] = None 
    task4set2event ['ZPU'] ['PROPERTIES'] = None            

    
    # ---------------------------------------------------------------------------------------------
    # (8) ERROR CODE - REQUIRED                            
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['CODE2ERROR'] = 0 
    task4set2event ['BPU'] ['CODE2ERROR'] = 0 
    task4set2event ['CPU'] ['CODE2ERROR'] = 0 
    task4set2event ['DPU'] ['CODE2ERROR'] = 0 
    task4set2event ['EPU'] ['CODE2ERROR'] = 0 
    task4set2event ['FPU'] ['CODE2ERROR'] = 0 
    task4set2event ['GPU'] ['CODE2ERROR'] = 0 
    task4set2event ['HPU'] ['CODE2ERROR'] = 0 
    task4set2event ['IPU'] ['CODE2ERROR'] = 0 
    task4set2event ['JPU'] ['CODE2ERROR'] = 0 
    task4set2event ['KPU'] ['CODE2ERROR'] = 0 
    task4set2event ['LPU'] ['CODE2ERROR'] = 0 
    task4set2event ['MPU'] ['CODE2ERROR'] = 0 
    task4set2event ['NPU'] ['CODE2ERROR'] = 0 
    task4set2event ['OPU'] ['CODE2ERROR'] = 0 
    task4set2event ['PPU'] ['CODE2ERROR'] = 0 
    task4set2event ['QPU'] ['CODE2ERROR'] = 0 
    task4set2event ['RPU'] ['CODE2ERROR'] = 0 
    task4set2event ['SPU'] ['CODE2ERROR'] = 0 
    task4set2event ['TPU'] ['CODE2ERROR'] = 0 
    task4set2event ['UPU'] ['CODE2ERROR'] = 0 
    task4set2event ['VPU'] ['CODE2ERROR'] = 0 
    task4set2event ['XPU'] ['CODE2ERROR'] = 0 
    task4set2event ['WPU'] ['CODE2ERROR'] = 0 
    task4set2event ['YPU'] ['CODE2ERROR'] = 0 
    task4set2event ['ZPU'] ['CODE2ERROR'] = 0         

    
    # ---------------------------------------------------------------------------------------------
    # (9) QUEUE - EXTRA                            
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['QUEUE'] = None 
    task4set2event ['BPU'] ['QUEUE'] = None 
    task4set2event ['CPU'] ['QUEUE'] = None 
    task4set2event ['DPU'] ['QUEUE'] = None 
    task4set2event ['EPU'] ['QUEUE'] = None 
    task4set2event ['FPU'] ['QUEUE'] = None 
    task4set2event ['GPU'] ['QUEUE'] = None 
    task4set2event ['HPU'] ['QUEUE'] = None 
    task4set2event ['IPU'] ['QUEUE'] = None 
    task4set2event ['JPU'] ['QUEUE'] = None 
    task4set2event ['KPU'] ['QUEUE'] = None 
    task4set2event ['LPU'] ['QUEUE'] = None 
    task4set2event ['MPU'] ['QUEUE'] = None 
    task4set2event ['NPU'] ['QUEUE'] = None 
    task4set2event ['OPU'] ['QUEUE'] = None 
    task4set2event ['PPU'] ['QUEUE'] = None 
    task4set2event ['QPU'] ['QUEUE'] = None 
    task4set2event ['RPU'] ['QUEUE'] = None 
    task4set2event ['SPU'] ['QUEUE'] = None 
    task4set2event ['TPU'] ['QUEUE'] = None 
    task4set2event ['UPU'] ['QUEUE'] = None 
    task4set2event ['VPU'] ['QUEUE'] = None 
    task4set2event ['XPU'] ['QUEUE'] = None 
    task4set2event ['WPU'] ['QUEUE'] = None 
    task4set2event ['YPU'] ['QUEUE'] = None 
    task4set2event ['ZPU'] ['QUEUE'] = None             
    
    # ---------------------------------------------------------------------------------------------
    # (9A) QUEUE FOR APU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9A1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['APU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9A2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['APU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9AZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9B) QUEUE FOR BPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9B1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['BPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9B2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['BPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9BZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9C) QUEUE FOR CPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9C1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['CPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9C2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['CPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9CZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9D) QUEUE FOR DPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9D1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['DPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9D2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['DPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9DZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
     
    
    # ---------------------------------------------------------------------------------------------
    # (9E) QUEUE FOR EPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9E1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['EPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9E2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['EPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9EZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9F) QUEUE FOR FPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9F1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['FPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9F2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['FPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9FZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9G) QUEUE FOR GPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9G1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['GPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9G2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['GPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9GZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9H) QUEUE FOR HPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9H1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['HPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9H2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['HPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9HZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9I) QUEUE FOR IPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9I1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['IPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9I2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['IPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9IZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9J) QUEUE FOR JPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9J1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['JPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9J2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['JPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9JZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9K) QUEUE FOR KPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9K1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['KPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9K2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['KPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9KZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9L) QUEUE FOR LPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9L1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['LPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9L2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['LPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9LZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9M) QUEUE FOR MPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9M1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['MPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9M2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['MPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9MZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9N) QUEUE FOR NPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9N1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['NPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9N2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['NPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9NZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9O) QUEUE FOR OPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9O1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['OPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9O2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['OPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9OZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9P) QUEUE FOR PPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9P1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['PPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9P2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['PPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9PZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9Q) QUEUE FOR QPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9Q1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['QPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9Q2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['QPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9QZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9R) QUEUE FOR RPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9R1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['RPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9R2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['RPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9RZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9S) QUEUE FOR SPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9S1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['SPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9S2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['SPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9SZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9T) QUEUE FOR TPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9T1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['TPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9T2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['TPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9TZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9U) QUEUE FOR UPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9U1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['UPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9U2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['UPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9UZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9V) QUEUE FOR VPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9V1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['VPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9V2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['VPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9VZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9W) QUEUE FOR WPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9W1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['WPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9W2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['WPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9WZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9X) QUEUE FOR XPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9X1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['XPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9X2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['XPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9XZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9Y) QUEUE FOR YPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9Y1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['YPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9Y2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['YPU'] ['QUEUE'])                           
        # 
        
    except:
        print('(Step 9YZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (9Z) QUEUE FOR ZPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 9Z1/33) OF EVENT4XI5TEST - TRYING TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['ZPU'] ['QUEUE'] = Queue4Xi()                                                                                                                    
        print('(Step 9Z2/33) OF EVENT4XI5TEST - QUEUE OF TASK4SET2EVENT: ', task4set2event ['ZPU'] ['QUEUE'])                           
        # <queue4xi.Queue4Xi object at 0x0000000006E9CA90>
        
    except:
        print('(Step 9ZZ/33) OF EVENT4XI5TEST *** FAILED TO SET QUEUE FOR TASK4SET2EVENT ', time4xi())  

    

            
    
    # ---------------------------------------------------------------------------------------------
    # (10) PIPE - EXTRA                            
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['PIPE'] = None 
    task4set2event ['BPU'] ['PIPE'] = None 
    task4set2event ['CPU'] ['PIPE'] = None 
    task4set2event ['DPU'] ['PIPE'] = None 
    task4set2event ['EPU'] ['PIPE'] = None 
    task4set2event ['FPU'] ['PIPE'] = None 
    task4set2event ['GPU'] ['PIPE'] = None 
    task4set2event ['HPU'] ['PIPE'] = None 
    task4set2event ['IPU'] ['PIPE'] = None 
    task4set2event ['JPU'] ['PIPE'] = None 
    task4set2event ['KPU'] ['PIPE'] = None 
    task4set2event ['LPU'] ['PIPE'] = None 
    task4set2event ['MPU'] ['PIPE'] = None 
    task4set2event ['NPU'] ['PIPE'] = None 
    task4set2event ['OPU'] ['PIPE'] = None 
    task4set2event ['PPU'] ['PIPE'] = None 
    task4set2event ['QPU'] ['PIPE'] = None 
    task4set2event ['RPU'] ['PIPE'] = None 
    task4set2event ['SPU'] ['PIPE'] = None 
    task4set2event ['TPU'] ['PIPE'] = None 
    task4set2event ['UPU'] ['PIPE'] = None 
    task4set2event ['VPU'] ['PIPE'] = None 
    task4set2event ['XPU'] ['PIPE'] = None 
    task4set2event ['WPU'] ['PIPE'] = None 
    task4set2event ['YPU'] ['PIPE'] = None 
    task4set2event ['ZPU'] ['PIPE'] = None             
    
    # ---------------------------------------------------------------------------------------------
    # (10A) PIPE FOR APU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10A1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['APU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10A2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['APU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10AZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10B) PIPE FOR BPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10B1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['BPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10B2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['BPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10BZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10C) PIPE FOR CPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10C1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['CPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10C2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['CPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10CZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10D) PIPE FOR DPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10D1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['DPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10D2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['DPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10DZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
     
    
    # ---------------------------------------------------------------------------------------------
    # (10E) PIPE FOR EPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10E1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['EPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10E2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['EPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10EZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10F) PIPE FOR FPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10F1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['FPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10F2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['FPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10FZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10G) PIPE FOR GPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10G1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['GPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10G2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['GPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10GZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10H) PIPE FOR HPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10H1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['HPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10H2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['HPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10HZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10I) PIPE FOR IPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10I1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['IPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10I2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['IPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10IZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10J) PIPE FOR JPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10J1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['JPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10J2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['JPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10JZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10K) PIPE FOR KPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10K1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['KPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10K2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['KPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10KZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10L) PIPE FOR LPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10L1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['LPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10L2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['LPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10LZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10M) PIPE FOR MPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10M1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['MPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10M2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['MPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10MZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10N) PIPE FOR NPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10N1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['NPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10N2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['NPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10NZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10O) PIPE FOR OPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10O1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['OPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10O2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['OPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10OZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10P) PIPE FOR PPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10P1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['PPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10P2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['PPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10PZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10Q) PIPE FOR QPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10Q1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['QPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10Q2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['QPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10QZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10R) PIPE FOR RPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10R1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['RPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10R2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['RPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10RZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10S) PIPE FOR SPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10S1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['SPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10S2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['SPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10SZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10T) PIPE FOR TPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10T1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['TPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10T2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['TPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10TZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10U) PIPE FOR UPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10U1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['UPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10U2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['UPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10UZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10V) PIPE FOR VPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10V1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['VPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10V2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['VPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10VZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10W) PIPE FOR WPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10W1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['WPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10W2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['WPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10WZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10X) PIPE FOR XPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10X1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['XPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10X2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['XPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10XZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10Y) PIPE FOR YPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10Y1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['YPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10Y2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['YPU'] ['PIPE'])                           
        # 
        
    except:
        print('(Step 10YZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  
    
    
    # ---------------------------------------------------------------------------------------------
    # (10Z) PIPE FOR ZPU                            
    # ---------------------------------------------------------------------------------------------     
    print('(Step 10Z1/33) OF EVENT4XI5TEST - TRYING TO SET PIPE FOR TASK4SET2EVENT ', time4xi())   
    try:                               
        task4set2event ['ZPU'] ['PIPE'] = Pipe4Xi()                                                                                                                    
        print('(Step 10Z2/33) OF EVENT4XI5TEST - PIPE OF TASK4SET2EVENT: ', task4set2event ['ZPU'] ['PIPE'])                           
        # (<read-write PipeConnection, handle 2860>, <read-write PipeConnection, handle 2864>) 
        
    except:
        print('(Step 10ZZ/33) OF EVENT4XI5TEST *** FAILED TO SET PIPE FOR TASK4SET2EVENT ', time4xi())  

        
     
          
    # ---------------------------------------------------------------------------------------------
    # (11A) COMMAND QUEUE FOR APU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['APU'] ['COMMANDQUEUE'] = None
    print('(Step 11A1/33) OF APU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR APU ', time4xi())   
    try:                               
        task4set2event ['APU'] ['COMMANDQUEUE'] = create2commandqueue4apu()                                                                                                                    
        print('(Step 11A2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4APU: ', task4set2event ['APU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11AZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4APU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11B) COMMAND QUEUE FOR BPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['BPU'] ['COMMANDQUEUE'] = None
    print('(Step 11B1/33) OF BPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR BPU ', time4xi())   
    try:                               
        task4set2event ['BPU'] ['COMMANDQUEUE'] = create2commandqueue4bpu()                                                                                                                    
        print('(Step 11B2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4BPU: ', task4set2event ['BPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11BZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4BPU ', time4xi())      
        

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11C) COMMAND QUEUE FOR CPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['CPU'] ['COMMANDQUEUE'] = None
    print('(Step 11C1/33) OF CPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR CPU ', time4xi())   
    try:                               
        task4set2event ['CPU'] ['COMMANDQUEUE'] = create2commandqueue4cpu()                                                                                                                    
        print('(Step 11C2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4CPU: ', task4set2event ['CPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11CZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4CPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11D) COMMAND QUEUE FOR DPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['DPU'] ['COMMANDQUEUE'] = None
    print('(Step 11D1/33) OF DPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR DPU ', time4xi())   
    try:                               
        task4set2event ['DPU'] ['COMMANDQUEUE'] = create2commandqueue4dpu()                                                                                                                    
        print('(Step 11D2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4DPU: ', task4set2event ['DPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11DZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4DPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11E) COMMAND QUEUE FOR EPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['EPU'] ['COMMANDQUEUE'] = None
    print('(Step 11E1/33) OF EPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR EPU ', time4xi())   
    try:                               
        task4set2event ['EPU'] ['COMMANDQUEUE'] = create2commandqueue4epu()                                                                                                                    
        print('(Step 11E2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4EPU: ', task4set2event ['EPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11EZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4EPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11F) COMMAND QUEUE FOR FPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['FPU'] ['COMMANDQUEUE'] = None
    print('(Step 11F1/33) OF FPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR FPU ', time4xi())   
    try:                               
        task4set2event ['FPU'] ['COMMANDQUEUE'] = create2commandqueue4fpu()                                                                                                                    
        print('(Step 11F2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4FPU: ', task4set2event ['FPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11FZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4FPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11G) COMMAND QUEUE FOR GPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['GPU'] ['COMMANDQUEUE'] = None
    print('(Step 11G1/33) OF GPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR GPU ', time4xi())   
    try:                               
        task4set2event ['GPU'] ['COMMANDQUEUE'] = create2commandqueue4gpu()                                                                                                                    
        print('(Step 11G2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4GPU: ', task4set2event ['GPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11GZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4GPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11H) COMMAND QUEUE FOR HPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['HPU'] ['COMMANDQUEUE'] = None
    print('(Step 11H1/33) OF HPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR HPU ', time4xi())   
    try:                               
        task4set2event ['HPU'] ['COMMANDQUEUE'] = create2commandqueue4hpu()                                                                                                                    
        print('(Step 11H2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4HPU: ', task4set2event ['HPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11HZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4HPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11I) COMMAND QUEUE FOR IPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['IPU'] ['COMMANDQUEUE'] = None
    print('(Step 11I1/33) OF IPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR IPU ', time4xi())   
    try:                               
        task4set2event ['IPU'] ['COMMANDQUEUE'] = create2commandqueue4ipu()                                                                                                                    
        print('(Step 11I2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4IPU: ', task4set2event ['IPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11IZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4IPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11J) COMMAND QUEUE FOR JPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['JPU'] ['COMMANDQUEUE'] = None
    print('(Step 11J1/33) OF JPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR JPU ', time4xi())   
    try:                               
        task4set2event ['JPU'] ['COMMANDQUEUE'] = create2commandqueue4jpu()                                                                                                                    
        print('(Step 11J2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4JPU: ', task4set2event ['JPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11JZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4JPU ', time4xi())      

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11K) COMMAND QUEUE FOR KPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['KPU'] ['COMMANDQUEUE'] = None
    print('(Step 11K1/33) OF KPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR KPU ', time4xi())   
    try:                               
        task4set2event ['KPU'] ['COMMANDQUEUE'] = create2commandqueue4kpu()                                                                                                                    
        print('(Step 11K2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4KPU: ', task4set2event ['KPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11KZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4KPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11L) COMMAND QUEUE FOR LPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['LPU'] ['COMMANDQUEUE'] = None
    print('(Step 11L1/33) OF LPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR LPU ', time4xi())   
    try:                               
        task4set2event ['LPU'] ['COMMANDQUEUE'] = create2commandqueue4lpu()                                                                                                                    
        print('(Step 11L2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4LPU: ', task4set2event ['LPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11LZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4LPU ', time4xi())    
                                                                                                                  

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11M) COMMAND QUEUE FOR MPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['MPU'] ['COMMANDQUEUE'] = None
    print('(Step 11M1/33) OF MPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR MPU ', time4xi())   
    try:                               
        task4set2event ['MPU'] ['COMMANDQUEUE'] = create2commandqueue4mpu()                                                                                                                    
        print('(Step 11M2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4MPU: ', task4set2event ['MPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11MZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4MPU ', time4xi())    
                   

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11N) COMMAND QUEUE FOR NPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['NPU'] ['COMMANDQUEUE'] = None
    print('(Step 11N1/33) OF NPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR NPU ', time4xi())   
    try:                               
        task4set2event ['NPU'] ['COMMANDQUEUE'] = create2commandqueue4npu()                                                                                                                    
        print('(Step 11N2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4NPU: ', task4set2event ['NPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11NZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4NPU ', time4xi())    
                   

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11O) COMMAND QUEUE FOR OPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['OPU'] ['COMMANDQUEUE'] = None
    print('(Step 11O1/33) OF OPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR OPU ', time4xi())   
    try:                               
        task4set2event ['OPU'] ['COMMANDQUEUE'] = create2commandqueue4opu()                                                                                                                    
        print('(Step 11O2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4OPU: ', task4set2event ['OPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11OZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4OPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11P) COMMAND QUEUE FOR PPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['PPU'] ['COMMANDQUEUE'] = None
    print('(Step 11P1/33) OF PPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR PPU ', time4xi())   
    try:                               
        task4set2event ['PPU'] ['COMMANDQUEUE'] = create2commandqueue4ppu()                                                                                                                    
        print('(Step 11P2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4PPU: ', task4set2event ['PPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11PZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4PPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11Q) COMMAND QUEUE FOR QPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['QPU'] ['COMMANDQUEUE'] = None
    print('(Step 11Q1/33) OF QPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR QPU ', time4xi())   
    try:                               
        task4set2event ['QPU'] ['COMMANDQUEUE'] = create2commandqueue4qpu()                                                                                                                    
        print('(Step 11Q2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4QPU: ', task4set2event ['QPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11QZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4QPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11R) COMMAND QUEUE FOR RPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['RPU'] ['COMMANDQUEUE'] = None
    print('(Step 11R1/33) OF RPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR RPU ', time4xi())   
    try:                               
        task4set2event ['RPU'] ['COMMANDQUEUE'] = create2commandqueue4rpu()                                                                                                                    
        print('(Step 11R2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4RPU: ', task4set2event ['RPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11RZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4RPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11S) COMMAND QUEUE FOR SPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['SPU'] ['COMMANDQUEUE'] = None
    print('(Step 11S1/33) OF SPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR SPU ', time4xi())   
    try:                               
        task4set2event ['SPU'] ['COMMANDQUEUE'] = create2commandqueue4spu()                                                                                                                    
        print('(Step 11S2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4SPU: ', task4set2event ['SPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11SZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4SPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11T) COMMAND QUEUE FOR TPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['TPU'] ['COMMANDQUEUE'] = None
    print('(Step 11T1/33) OF TPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR TPU ', time4xi())   
    try:                               
        task4set2event ['TPU'] ['COMMANDQUEUE'] = create2commandqueue4tpu()                                                                                                                    
        print('(Step 11T2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4TPU: ', task4set2event ['TPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11TZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4TPU ', time4xi())    
                  

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11U) COMMAND QUEUE FOR UPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['UPU'] ['COMMANDQUEUE'] = None
    print('(Step 11U1/33) OF UPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR UPU ', time4xi())   
    try:                               
        task4set2event ['UPU'] ['COMMANDQUEUE'] = create2commandqueue4upu()                                                                                                                    
        print('(Step 11U2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4UPU: ', task4set2event ['UPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11UZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4UPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11V) COMMAND QUEUE FOR VPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['VPU'] ['COMMANDQUEUE'] = None
    print('(Step 11V1/33) OF VPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR VPU ', time4xi())   
    try:                               
        task4set2event ['VPU'] ['COMMANDQUEUE'] = create2commandqueue4vpu()                                                                                                                    
        print('(Step 11V2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4VPU: ', task4set2event ['VPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11VZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4VPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11W) COMMAND QUEUE FOR WPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['WPU'] ['COMMANDQUEUE'] = None
    print('(Step 11W1/33) OF WPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR WPU ', time4xi())   
    try:                               
        task4set2event ['WPU'] ['COMMANDQUEUE'] = create2commandqueue4wpu()                                                                                                                    
        print('(Step 11W2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4WPU: ', task4set2event ['WPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11WZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4WPU ', time4xi())    

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11Y) COMMAND QUEUE FOR YPU                            
    # ---------------------------------------------------------------------------------------------
    task4set2event ['YPU'] ['COMMANDQUEUE'] = None
    print('(Step 11Y1/33) OF YPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR YPU ', time4xi())   
    try:                               
        task4set2event ['YPU'] ['COMMANDQUEUE'] = create2commandqueue4ypu()                                                                                                                    
        print('(Step 11Y2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4YPU: ', task4set2event ['YPU'] ['COMMANDQUEUE'])                           
        # 
    except:
        print('(Step 11YZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4YPU ', time4xi())    
                   

    
     
          
    # ---------------------------------------------------------------------------------------------
    # (11Z) COMMAND QUEUE FOR ZPU                            
    # ------------------------------------------------------------------------------------------
    task4set2event ['ZPU'] ['COMMANDQUEUE'] = None
    print('(Step 111/33) OF ZPU2EVENT4XI5TEST - TRYING TO SET COMMAND QUEUE FOR ZPU ', time4xi())   
    try:                               
        task4set2event ['ZPU'] ['COMMANDQUEUE'] = create2commandqueue4zpu()                                                                                                                    
        print('(Step 11Z2/33) OF EVENT4XI5TEST - COMMAND QUEUE OF EVENT4ZPU: ', task4set2event ['ZPU'] ['COMMANDQUEUE'])                           
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4zpu-failed ; time: 04:19:55 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4zpu', 'METHOD': 'create2commandqueue4zpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4zpu at 0x000000000458A048>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x0000000007B3F710>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4zpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4zpu', 'METHOD': 'create2context4zpu'}, 'FUNCTION2CALLBACK': <function trace2context4zpu at 0x00000000045355C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_ZPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 3664>, <read-write PipeConnection, handle 3668>)}

    except:
        print('(Step 11ZZ/33) OF EVENT4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR EVENT4ZPU ', time4xi())    
                   


                                                                                                                                    
    # -----------------------------------------------------------------------------------------
    # (12) SET EVENT TO ALL DEVICES - FINALLY! 
    # -----------------------------------------------------------------------------------------      
    response4set2event = {} 
    print('(Step 12A/33) OF EVENT4XI5TEST - TRYING TO GET RESPONSE FOR SET2EVENT4XI ', time4xi())   
    try:                               
        response4set2event = set2event4xi(task4set2event)                                                     # ALL ATTRIBUTES SET                                                        
        print('(Step 12B/33) OF EVENT4XI5TEST - RESPONSE4SET2EVENT : ', response4set2event)                           
        # {'DPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 'ACK2RETURN': ' 4B-5B-6B-7B-8B-9B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000066A2198>, 'NACK2RETURN': ' 2Z1-3Z1-', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:19:55 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003AE8248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000072C76D8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 2988>, <read-write PipeConnection, handle 2992>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 2684>, <read-write PipeConnection, handle 2688>)}, 
        #  'EPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4epu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4epu', 'METHOD': 'create2event4epu'}, 'FUNCTION2CALLBACK': <function trace2event4epu at 0x0000000003C2D848>, 'ACK2RETURN': ' 4B-5B-6B-7B-8B-9B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000066C21D0>, 'NACK2RETURN': ' 2Z1-3Z1-', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B09648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4epu-failed ; time: 04:19:55 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4epu', 'METHOD': 'create2commandqueue4epu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4epu at 0x0000000003C2D0C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000736E4A8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B09648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 3020>, <read-write PipeConnection, handle 3024>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 2692>, <read-write PipeConnection, handle 2696>)}, 
        #  ...
        
    except:
        print('(Step 12Z/33) OF EVENT4XI5TEST *** FAILED TO GET RESPONSE FOR SET2EVENT4XI ', time4xi())  
        
    
    # ---------------------------------------------------------------------------------------------
    # (13) RELEASE REFERENCE COUNT FOR EVENT BY DECREMENTING COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    task4release2event = {}
    task4release2event ['APU'] = {} 
    task4release2event ['BPU'] = {} 
    task4release2event ['CPU'] = {} 
    task4release2event ['DPU'] = {} 
    task4release2event ['EPU'] = {} 
    task4release2event ['FPU'] = {} 
    task4release2event ['GPU'] = {} 
    task4release2event ['HPU'] = {} 
    task4release2event ['IPU'] = {} 
    task4release2event ['JPU'] = {} 
    task4release2event ['KPU'] = {} 
    task4release2event ['LPU'] = {} 
    task4release2event ['MPU'] = {} 
    task4release2event ['NPU'] = {} 
    task4release2event ['OPU'] = {} 
    task4release2event ['PPU'] = {} 
    task4release2event ['QPU'] = {} 
    task4release2event ['RPU'] = {} 
    task4release2event ['SPU'] = {} 
    task4release2event ['TPU'] = {} 
    task4release2event ['UPU'] = {} 
    task4release2event ['VPU'] = {} 
    task4release2event ['XPU'] = {} 
    task4release2event ['WPU'] = {} 
    task4release2event ['YPU'] = {} 
    task4release2event ['ZPU'] = {} 
     
    task4release2event ['APU'] ['COUNT2REFERENCE'] = 1                                                       
    task4release2event ['BPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['CPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['DPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['EPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['FPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['GPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['HPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['IPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['JPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['KPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['LPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['MPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['NPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['OPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['PPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['QPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['RPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['SPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['TPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['UPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['VPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['XPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['WPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['YPU'] ['COUNT2REFERENCE'] = 1    
    task4release2event ['ZPU'] ['COUNT2REFERENCE'] = 1      
    
    response4release2event = {}
    
    print('(Step 13A/33) OF EVENT4XI5TEST - TRYING TO RELEASE EVENT OF EACH DEVICE ', time4xi())   
    try:                               
        response4release2event = release2event4xi(task4release2event)                                         # COUNT2REFERENCE                                                      
        print('(Step 13B/33) OF EVENT4XI5TEST - RESPONSE4RELEASE2EVENT : ', response4release2event)                           
        # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 'ACK2RETURN': ' ', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000066A2198>, 'NACK2RETURN': ' 8Z1-', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:19:55 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003AE8248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000072C76D8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 2988>, <read-write PipeConnection, handle 2992>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 2684>, <read-write PipeConnection, handle 2688>)}, 
        # ...
     
    except:
        print('(Step 13Z/33) OF EVENT4XI5TEST *** FAILED TO RELEASE EVENT OF EACH DEVICE ', time4xi())  
                
    
    # ---------------------------------------------------------------------------------------------
    # (14) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAINED BY INCREMENTING COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    task4retain2event = {}
    task4retain2event ['APU'] = {} 
    task4retain2event ['BPU'] = {} 
    task4retain2event ['CPU'] = {} 
    task4retain2event ['DPU'] = {} 
    task4retain2event ['EPU'] = {} 
    task4retain2event ['FPU'] = {} 
    task4retain2event ['GPU'] = {} 
    task4retain2event ['HPU'] = {} 
    task4retain2event ['IPU'] = {} 
    task4retain2event ['JPU'] = {} 
    task4retain2event ['KPU'] = {} 
    task4retain2event ['LPU'] = {} 
    task4retain2event ['MPU'] = {} 
    task4retain2event ['NPU'] = {} 
    task4retain2event ['OPU'] = {} 
    task4retain2event ['PPU'] = {} 
    task4retain2event ['QPU'] = {} 
    task4retain2event ['RPU'] = {} 
    task4retain2event ['SPU'] = {} 
    task4retain2event ['TPU'] = {} 
    task4retain2event ['UPU'] = {} 
    task4retain2event ['VPU'] = {} 
    task4retain2event ['XPU'] = {} 
    task4retain2event ['WPU'] = {} 
    task4retain2event ['YPU'] = {} 
    task4retain2event ['ZPU'] = {} 
     
    task4retain2event ['APU'] ['COUNT2REFERENCE'] = 1                                                            
    task4retain2event ['BPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['CPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['DPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['EPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['FPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['GPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['HPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['IPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['JPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['KPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['LPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['MPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['NPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['OPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['PPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['QPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['RPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['SPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['TPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['UPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['VPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['XPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['WPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['YPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['ZPU'] ['COUNT2REFERENCE'] = 1        
    
    response4retain2event = {}
    
    print('(Step 14A/33) OF EVENT4XI5TEST - TRYING TO RETAIN EVENT OF EACH DEVICE ', time4xi())  
    try:                               
        response4retain2event = retain2event4xi(task4retain2event)                                 # COUNT2REFERENCE                                                      
        print('(Step 14B/33) OF EVENT4XI5TEST - RESPONSE4RELEASE2EVENT : ', response4retain2event)                          
        # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 'ACK2RETURN': ' 1D-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000066A2198>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:19:55 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003AE8248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000072C76D8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 2988>, <read-write PipeConnection, handle 2992>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 2684>, <read-write PipeConnection, handle 2688>)}, 
        #  ...

    except:
        print('(Step 14Z/33) OF EVENT4XI5TEST *** FAILED TO RETAIN EVENT OF EACH DEVICE ', time4xi())  

    # ---------------------------------------------------------------------------------------------
    # (15) CALLBACK              
    # ---------------------------------------------------------------------------------------------    
    task4set2eventcallback = {}
    task4set2eventcallback ['APU'] = {} 
    task4set2eventcallback ['BPU'] = {} 
    task4set2eventcallback ['CPU'] = {} 
    task4set2eventcallback ['DPU'] = {} 
    task4set2eventcallback ['EPU'] = {} 
    task4set2eventcallback ['FPU'] = {} 
    task4set2eventcallback ['GPU'] = {} 
    task4set2eventcallback ['HPU'] = {} 
    task4set2eventcallback ['IPU'] = {} 
    task4set2eventcallback ['JPU'] = {} 
    task4set2eventcallback ['KPU'] = {} 
    task4set2eventcallback ['LPU'] = {} 
    task4set2eventcallback ['MPU'] = {} 
    task4set2eventcallback ['NPU'] = {} 
    task4set2eventcallback ['OPU'] = {} 
    task4set2eventcallback ['PPU'] = {} 
    task4set2eventcallback ['QPU'] = {} 
    task4set2eventcallback ['RPU'] = {} 
    task4set2eventcallback ['SPU'] = {} 
    task4set2eventcallback ['TPU'] = {} 
    task4set2eventcallback ['UPU'] = {} 
    task4set2eventcallback ['VPU'] = {} 
    task4set2eventcallback ['XPU'] = {} 
    task4set2eventcallback ['WPU'] = {} 
    task4set2eventcallback ['YPU'] = {} 
    task4set2eventcallback ['ZPU'] = {} 
        
    task4set2eventcallback ['APU'] ['CALLBACK'] = set2eventcallback4apu() 
    task4set2eventcallback ['BPU'] ['CALLBACK'] = set2eventcallback4bpu() 
    task4set2eventcallback ['CPU'] ['CALLBACK'] = set2eventcallback4cpu() 
    task4set2eventcallback ['DPU'] ['CALLBACK'] = set2eventcallback4dpu() 
    task4set2eventcallback ['EPU'] ['CALLBACK'] = set2eventcallback4epu() 
    task4set2eventcallback ['FPU'] ['CALLBACK'] = set2eventcallback4fpu() 
    task4set2eventcallback ['GPU'] ['CALLBACK'] = set2eventcallback4gpu() 
    task4set2eventcallback ['HPU'] ['CALLBACK'] = set2eventcallback4hpu() 
    task4set2eventcallback ['IPU'] ['CALLBACK'] = set2eventcallback4ipu() 
    task4set2eventcallback ['JPU'] ['CALLBACK'] = set2eventcallback4jpu() 
    task4set2eventcallback ['KPU'] ['CALLBACK'] = set2eventcallback4kpu() 
    task4set2eventcallback ['LPU'] ['CALLBACK'] = set2eventcallback4lpu() 
    task4set2eventcallback ['MPU'] ['CALLBACK'] = set2eventcallback4mpu() 
    task4set2eventcallback ['NPU'] ['CALLBACK'] = set2eventcallback4npu() 
    task4set2eventcallback ['OPU'] ['CALLBACK'] = set2eventcallback4opu() 
    task4set2eventcallback ['PPU'] ['CALLBACK'] = set2eventcallback4ppu() 
    task4set2eventcallback ['QPU'] ['CALLBACK'] = set2eventcallback4qpu() 
    task4set2eventcallback ['RPU'] ['CALLBACK'] = set2eventcallback4rpu() 
    task4set2eventcallback ['SPU'] ['CALLBACK'] = set2eventcallback4spu() 
    task4set2eventcallback ['TPU'] ['CALLBACK'] = set2eventcallback4tpu() 
    task4set2eventcallback ['UPU'] ['CALLBACK'] = set2eventcallback4upu() 
    task4set2eventcallback ['VPU'] ['CALLBACK'] = set2eventcallback4vpu() 
    task4set2eventcallback ['XPU'] ['CALLBACK'] = set2eventcallback4wpu() 
    task4set2eventcallback ['WPU'] ['CALLBACK'] = set2eventcallback4xpu() 
    task4set2eventcallback ['YPU'] ['CALLBACK'] = set2eventcallback4ypu() 
    task4set2eventcallback ['ZPU'] ['CALLBACK'] = set2eventcallback4zpu() 
    
    print('(Step 15A/33) OF EVENT4XI5TEST - TRYING TO SET EVENT CALLBACK BY CALLING SET2EVENTCALLBACK4XI: ', set2eventcallback4xi)    
    #     
    try:                               
        response4setcallback2event = set2eventcallback4xi(task4set2eventcallback)                                                                                                 
        print('(Step 15B/33) OF EVENT4XI5TEST - RESPONSE4SETCALLBACK2EVENT : ', response4setcallback2event)                          
        # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:19:52 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 'ACK2RETURN': ' 1D-', 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000066A2198>, 
        #          'CALLBACK': <function trace2event4dpu at 0x0000000003AE89C8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 04:19:55 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003AE8248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000072C76D8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 04:19:54 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FA97C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 2988>, <read-write PipeConnection, handle 2992>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 2684>, <read-write PipeConnection, handle 2688>)}, 
        # ...
        
    except:
        print('(Step 15Z/33) OF EVENT4XI5TEST *** FAILED TO SET EVENT CALLBACK ', time4xi())  
    

    # ---------------------------------------------------------------------------------------------
    # (15) TRACE              
    # ---------------------------------------------------------------------------------------------    
    task4trace2event = {}
    
    task4trace2event ['APU'] = {} 
    task4trace2event ['BPU'] = {} 
    task4trace2event ['CPU'] = {} 
    task4trace2event ['DPU'] = {} 
    task4trace2event ['EPU'] = {} 
    
    task4trace2event ['FPU'] = {} 
    task4trace2event ['GPU'] = {} 
    task4trace2event ['HPU'] = {} 
    task4trace2event ['IPU'] = {} 
    task4trace2event ['JPU'] = {} 
    
    task4trace2event ['KPU'] = {} 
    task4trace2event ['LPU'] = {} 
    task4trace2event ['MPU'] = {} 
    task4trace2event ['NPU'] = {} 
    task4trace2event ['OPU'] = {} 
    
    task4trace2event ['PPU'] = {} 
    task4trace2event ['QPU'] = {} 
    task4trace2event ['RPU'] = {} 
    task4trace2event ['SPU'] = {} 
    task4trace2event ['TPU'] = {} 
    
    task4trace2event ['UPU'] = {} 
    task4trace2event ['VPU'] = {}
    task4trace2event ['WPU'] = {}      
    task4trace2event ['XPU'] = {} 
    task4trace2event ['YPU'] = {} 
    
    task4trace2event ['ZPU'] = {} 
        
    task4trace2event ['APU'] ['TRACE'] = trace2event4apu() 
    task4trace2event ['BPU'] ['TRACE'] = trace2event4bpu() 
    task4trace2event ['CPU'] ['TRACE'] = trace2event4cpu() 
    task4trace2event ['DPU'] ['TRACE'] = trace2event4dpu() 
    task4trace2event ['EPU'] ['TRACE'] = trace2event4epu() 
    
    task4trace2event ['FPU'] ['TRACE'] = trace2event4fpu() 
    task4trace2event ['GPU'] ['TRACE'] = trace2event4gpu() 
    task4trace2event ['HPU'] ['TRACE'] = trace2event4hpu() 
    task4trace2event ['IPU'] ['TRACE'] = trace2event4ipu() 
    task4trace2event ['JPU'] ['TRACE'] = trace2event4jpu() 
    
    task4trace2event ['KPU'] ['TRACE'] = trace2event4kpu() 
    task4trace2event ['LPU'] ['TRACE'] = trace2event4lpu() 
    task4trace2event ['MPU'] ['TRACE'] = trace2event4mpu() 
    task4trace2event ['NPU'] ['TRACE'] = trace2event4npu() 
    task4trace2event ['OPU'] ['TRACE'] = trace2event4opu() 
    
    task4trace2event ['PPU'] ['TRACE'] = trace2event4ppu() 
    task4trace2event ['QPU'] ['TRACE'] = trace2event4qpu() 
    task4trace2event ['RPU'] ['TRACE'] = trace2event4rpu() 
    task4trace2event ['SPU'] ['TRACE'] = trace2event4spu() 
    task4trace2event ['TPU'] ['TRACE'] = trace2event4tpu() 
    
    task4trace2event ['UPU'] ['TRACE'] = trace2event4upu() 
    task4trace2event ['VPU'] ['TRACE'] = trace2event4vpu() 
    task4trace2event ['XPU'] ['TRACE'] = trace2event4wpu() 
    task4trace2event ['WPU'] ['TRACE'] = trace2event4xpu() 
    task4trace2event ['YPU'] ['TRACE'] = trace2event4ypu() 
    
    task4trace2event ['ZPU'] ['TRACE'] = trace2event4zpu() 
    
    print('(Step 15A/33) OF EVENT4XI5TEST - TRYING TO TRACE EVENTS BY CALLING TRACE2EVENT4XI: ', trace2event4xi)    
    #     
    try:                               
        response4trace2event = trace2event4xi(task4trace2event)                                                                                                 
        print('(Step 15B/33) OF EVENT4XI5TEST - RESPONSE4SETTRACE2EVENT : ', response4trace2event)                            
        # {'DPU': None, 'EPU': None, 'BPU': None, 'CPU': None, 'VPU': None, 'RPU': None, 'WPU': None, 'SPU': None, 'PPU': None, 'QPU': None, 'KPU': None, 'YPU': None, 'LPU': None, 'ZPU': None, 'HPU': None, 'FPU': None, 'TPU': None, 'GPU': None, 'UPU': None, 'XPU': None, 'OPU': None, 'APU': None, 'MPU': None, 'IPU': None, 'NPU': None, 'JPU': None}

    except:
        print('(Step 15Z/33) OF EVENT4XI5TEST *** FAILED TO TRACE EVENTS ', time4xi())  
    

    # ---------------------------------------------------------------------------------------------
    # (16) WAIT              
    # ---------------------------------------------------------------------------------------------    
    task4wait2event = {}
    task4wait2event ['APU'] = {} 
    task4wait2event ['BPU'] = {} 
    task4wait2event ['CPU'] = {} 
    task4wait2event ['DPU'] = {} 
    task4wait2event ['EPU'] = {} 
    task4wait2event ['FPU'] = {} 
    task4wait2event ['GPU'] = {} 
    task4wait2event ['HPU'] = {} 
    task4wait2event ['IPU'] = {} 
    task4wait2event ['JPU'] = {} 
    task4wait2event ['KPU'] = {} 
    task4wait2event ['LPU'] = {} 
    task4wait2event ['MPU'] = {} 
    task4wait2event ['NPU'] = {} 
    task4wait2event ['OPU'] = {} 
    task4wait2event ['PPU'] = {} 
    task4wait2event ['QPU'] = {} 
    task4wait2event ['RPU'] = {} 
    task4wait2event ['SPU'] = {} 
    task4wait2event ['TPU'] = {} 
    task4wait2event ['UPU'] = {} 
    task4wait2event ['VPU'] = {} 
    task4wait2event ['XPU'] = {} 
    task4wait2event ['WPU'] = {} 
    task4wait2event ['YPU'] = {} 
    task4wait2event ['ZPU'] = {} 
        
    task4wait2event ['APU'] ['WAIT'] = wait2event4apu() 
    task4wait2event ['BPU'] ['WAIT'] = wait2event4bpu() 
    task4wait2event ['CPU'] ['WAIT'] = wait2event4cpu() 
    task4wait2event ['DPU'] ['WAIT'] = wait2event4dpu() 
    task4wait2event ['EPU'] ['WAIT'] = wait2event4epu() 
    task4wait2event ['FPU'] ['WAIT'] = wait2event4fpu() 
    task4wait2event ['GPU'] ['WAIT'] = wait2event4gpu() 
    task4wait2event ['HPU'] ['WAIT'] = wait2event4hpu() 
    task4wait2event ['IPU'] ['WAIT'] = wait2event4ipu() 
    task4wait2event ['JPU'] ['WAIT'] = wait2event4jpu() 
    task4wait2event ['KPU'] ['WAIT'] = wait2event4kpu() 
    task4wait2event ['LPU'] ['WAIT'] = wait2event4lpu() 
    task4wait2event ['MPU'] ['WAIT'] = wait2event4mpu() 
    task4wait2event ['NPU'] ['WAIT'] = wait2event4npu() 
    task4wait2event ['OPU'] ['WAIT'] = wait2event4opu() 
    task4wait2event ['PPU'] ['WAIT'] = wait2event4ppu() 
    task4wait2event ['QPU'] ['WAIT'] = wait2event4qpu() 
    task4wait2event ['RPU'] ['WAIT'] = wait2event4rpu() 
    task4wait2event ['SPU'] ['WAIT'] = wait2event4spu() 
    task4wait2event ['TPU'] ['WAIT'] = wait2event4tpu() 
    task4wait2event ['UPU'] ['WAIT'] = wait2event4upu() 
    task4wait2event ['VPU'] ['WAIT'] = wait2event4vpu() 
    task4wait2event ['XPU'] ['WAIT'] = wait2event4wpu() 
    task4wait2event ['WPU'] ['WAIT'] = wait2event4xpu() 
    task4wait2event ['YPU'] ['WAIT'] = wait2event4ypu() 
    task4wait2event ['ZPU'] ['WAIT'] = wait2event4zpu() 
    
    print('(Step 16A/33) OF EVENT4XI5TEST - TRYING TO WAIT EVENTS BY CALLING WAIT2EVENT4XI: ', wait2event4xi)       
    # <function wait2event4xi at 0x00000000045DB148>     
    try:                               
        response4wait2event = wait2event4xi(task4wait2event)                                                                                                  
        print('(Step 16B/33) OF EVENT4XI5TEST - RESPONSE4SETWAIT2EVENT : ', response4wait2event)                          
        # 
        
    except:
        print('(Step 16Z/33) OF EVENT4XI5TEST *** FAILED TO WAIT EVENTS ', time4xi())                                                                              


   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS                          
    # ---------------------------------------------------------------------------------------------
    print('=' *33)          
    print('(Step 17A/33) OF EVENT4XI5TEST - CREATING EVENT4XI OBJECT')
    print('=' *33)  
    try:
        # ---------------------------------------------------------------------------------------------
        # CREATE WITH OBJECT                        
        # ---------------------------------------------------------------------------------------------        
        cc2xi = Event4Xi()
        print('(Step 17B/33) OF EVENT4XI5TEST - CREATED EVENT4XI OBJECT: ', cc2xi)                                  
        # <event4xi.Event4Xi object at 0x0000000008F6F0F0> 
        
    except:
        print('(Step 17Z/33) OF EVENT4XI5TEST *** FAILED TO CREATE EVENT4XI OBJECT')
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH METHOD                  
    # ---------------------------------------------------------------------------------------------          
    print('(Step 18A/33) OF EVENT4XI5TEST - TRYING TO GET EVENT INFO') 
    try:                               
        context6xi = cc2xi.get2eventinfo()                                  
        print('(Step 18B/33) OF EVENT4XI5TEST - GOT EVENT INFO: ', context6xi)                                           
        # {'DPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 06:02:15 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003B139C8>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6B-7B-8B-9B-10B-11B-12B-14B-15B-16B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000921DC88>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 06:02:12 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD27C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 06:02:15 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003B13248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x00000000092B70B8>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 06:02:12 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD27C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 1756>, <read-write PipeConnection, handle 1760>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 1852>, <read-write PipeConnection, handle 1856>)}, 
        #  'EPU': ...
        
    except:
        print('(Step 18Z/33) OF EVENT4XI5TEST *** FAILED TO GET EVENT INFO')   
     
    
    
    # ---------------------------------------------------------------------------------------------
    # SET WITH METHOD            
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 19A/33) OF EVENT4XI5TEST - TRYING TO SET EVENT ', time4xi()) 
    print('=' *33)       

          
    # ---------------------------------------------------------------------------------------------
    # (14) INITIALIZE TASK DICTIONARY FOR ALL DEVICES                          
    # ---------------------------------------------------------------------------------------------            
    task4set2event = {}
    task4set2event ['APU'] = {}
    task4set2event ['BPU'] = {}
    task4set2event ['CPU'] = {}
    task4set2event ['DPU'] = {}
    task4set2event ['EPU'] = {}
    task4set2event ['FPU'] = {}
    task4set2event ['GPU'] = {}
    task4set2event ['HPU'] = {}
    task4set2event ['IPU'] = {}
    task4set2event ['JPU'] = {}
    task4set2event ['KPU'] = {}
    task4set2event ['LPU'] = {}
    task4set2event ['MPU'] = {}
    task4set2event ['NPU'] = {}
    task4set2event ['OPU'] = {}
    task4set2event ['PPU'] = {}
    task4set2event ['QPU'] = {}
    task4set2event ['RPU'] = {}
    task4set2event ['SPU'] = {}
    task4set2event ['TPU'] = {}
    task4set2event ['UPU'] = {}
    task4set2event ['VPU'] = {}
    task4set2event ['XPU'] = {}
    task4set2event ['WPU'] = {}
    task4set2event ['YPU'] = {}
    task4set2event ['ZPU'] = {}
    
    # ---------------------------------------------------------------------------------------------
    # (15) DEFINE CONTEXT                           
    # ---------------------------------------------------------------------------------------------         
    task4set2event ['APU'] ['CONTEXT'] = context2xi ['APU'] 
    task4set2event ['BPU'] ['CONTEXT'] = context2xi ['BPU'] 
    task4set2event ['CPU'] ['CONTEXT'] = context2xi ['CPU'] 
    task4set2event ['DPU'] ['CONTEXT'] = context2xi ['DPU'] 
    task4set2event ['EPU'] ['CONTEXT'] = context2xi ['EPU'] 
    task4set2event ['FPU'] ['CONTEXT'] = context2xi ['FPU'] 
    task4set2event ['GPU'] ['CONTEXT'] = context2xi ['GPU'] 
    task4set2event ['HPU'] ['CONTEXT'] = context2xi ['HPU'] 
    task4set2event ['IPU'] ['CONTEXT'] = context2xi ['IPU'] 
    task4set2event ['JPU'] ['CONTEXT'] = context2xi ['JPU'] 
    task4set2event ['KPU'] ['CONTEXT'] = context2xi ['KPU'] 
    task4set2event ['LPU'] ['CONTEXT'] = context2xi ['LPU'] 
    task4set2event ['MPU'] ['CONTEXT'] = context2xi ['MPU'] 
    task4set2event ['NPU'] ['CONTEXT'] = context2xi ['NPU'] 
    task4set2event ['OPU'] ['CONTEXT'] = context2xi ['OPU'] 
    task4set2event ['PPU'] ['CONTEXT'] = context2xi ['PPU'] 
    task4set2event ['QPU'] ['CONTEXT'] = context2xi ['QPU'] 
    task4set2event ['RPU'] ['CONTEXT'] = context2xi ['RPU'] 
    task4set2event ['SPU'] ['CONTEXT'] = context2xi ['SPU'] 
    task4set2event ['TPU'] ['CONTEXT'] = context2xi ['TPU'] 
    task4set2event ['UPU'] ['CONTEXT'] = context2xi ['UPU'] 
    task4set2event ['VPU'] ['CONTEXT'] = context2xi ['VPU'] 
    task4set2event ['XPU'] ['CONTEXT'] = context2xi ['XPU'] 
    task4set2event ['WPU'] ['CONTEXT'] = context2xi ['WPU'] 
    task4set2event ['YPU'] ['CONTEXT'] = context2xi ['YPU'] 
    task4set2event ['ZPU'] ['CONTEXT'] = context2xi ['ZPU']                            
    
    # ---------------------------------------------------------------------------------------------
    # (20) SET DEVICES                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 20A/33) OF EVENT4XI5TEST - TRYING TO SET DEVICES', time4xi())
    print('=' *33)    
    try:
        
        device2xi = get2device4xi()
        print('(Step 20B/33) OF EVENT4XI5TEST - GOT DEVICE4XI: ', device2xi) 
        # 
        
        task4set2event ['APU'] ['DEVICE'] = device2xi ['APU']
        task4set2event ['BPU'] ['DEVICE'] = device2xi ['BPU']
        task4set2event ['CPU'] ['DEVICE'] = device2xi ['CPU']
        task4set2event ['DPU'] ['DEVICE'] = device2xi ['DPU']
        task4set2event ['EPU'] ['DEVICE'] = device2xi ['EPU']
        task4set2event ['FPU'] ['DEVICE'] = device2xi ['FPU']
        task4set2event ['GPU'] ['DEVICE'] = device2xi ['GPU']
        task4set2event ['HPU'] ['DEVICE'] = device2xi ['HPU']
        task4set2event ['IPU'] ['DEVICE'] = device2xi ['IPU']
        task4set2event ['JPU'] ['DEVICE'] = device2xi ['JPU']
        task4set2event ['KPU'] ['DEVICE'] = device2xi ['KPU']
        task4set2event ['LPU'] ['DEVICE'] = device2xi ['LPU']
        task4set2event ['MPU'] ['DEVICE'] = device2xi ['MPU']
        task4set2event ['NPU'] ['DEVICE'] = device2xi ['NPU']
        task4set2event ['OPU'] ['DEVICE'] = device2xi ['OPU']
        task4set2event ['PPU'] ['DEVICE'] = device2xi ['PPU']
        task4set2event ['QPU'] ['DEVICE'] = device2xi ['QPU']
        task4set2event ['RPU'] ['DEVICE'] = device2xi ['RPU']
        task4set2event ['SPU'] ['DEVICE'] = device2xi ['SPU']
        task4set2event ['TPU'] ['DEVICE'] = device2xi ['TPU']
        task4set2event ['UPU'] ['DEVICE'] = device2xi ['UPU']
        task4set2event ['VPU'] ['DEVICE'] = device2xi ['VPU']
        task4set2event ['XPU'] ['DEVICE'] = device2xi ['XPU']
        task4set2event ['WPU'] ['DEVICE'] = device2xi ['WPU']
        task4set2event ['YPU'] ['DEVICE'] = device2xi ['YPU']
        task4set2event ['ZPU'] ['DEVICE'] = device2xi ['ZPU']
         
    except:
        print('(Step 20Z/33) OF EVENT4XI5TEST *** FAILED TO SET DEVICES ', time4xi())    
    

    # ---------------------------------------------------------------------------------------------
    # (21) ERROR CODE - REQUIRED                            
    # ---------------------------------------------------------------------------------------------         
        task4set2event ['APU'] ['CODE2ERROR'] = 0
        task4set2event ['BPU'] ['CODE2ERROR'] = 0
        task4set2event ['CPU'] ['CODE2ERROR'] = 0
        task4set2event ['DPU'] ['CODE2ERROR'] = 0
        task4set2event ['EPU'] ['CODE2ERROR'] = 0
        task4set2event ['FPU'] ['CODE2ERROR'] = 0
        task4set2event ['GPU'] ['CODE2ERROR'] = 0
        task4set2event ['HPU'] ['CODE2ERROR'] = 0
        task4set2event ['IPU'] ['CODE2ERROR'] = 0
        task4set2event ['JPU'] ['CODE2ERROR'] = 0
        task4set2event ['KPU'] ['CODE2ERROR'] = 0
        task4set2event ['LPU'] ['CODE2ERROR'] = 0
        task4set2event ['MPU'] ['CODE2ERROR'] = 0
        task4set2event ['NPU'] ['CODE2ERROR'] = 0
        task4set2event ['OPU'] ['CODE2ERROR'] = 0
        task4set2event ['PPU'] ['CODE2ERROR'] = 0
        task4set2event ['QPU'] ['CODE2ERROR'] = 0
        task4set2event ['RPU'] ['CODE2ERROR'] = 0
        task4set2event ['SPU'] ['CODE2ERROR'] = 0
        task4set2event ['TPU'] ['CODE2ERROR'] = 0
        task4set2event ['UPU'] ['CODE2ERROR'] = 0
        task4set2event ['VPU'] ['CODE2ERROR'] = 0
        task4set2event ['XPU'] ['CODE2ERROR'] = 0
        task4set2event ['WPU'] ['CODE2ERROR'] = 0
        task4set2event ['YPU'] ['CODE2ERROR'] = 0
        task4set2event ['ZPU'] ['CODE2ERROR'] = 0    

    
    # ---------------------------------------------------------------------------------------------
    # (22) QUEUE - EXTRA                            
    # --------------------------------------------------------------------------------------------- 
    print('(Step 22A/33) OF EVENT4XI5TEST - TRYING CREATE QUEUES FOR TASK4SET2EVENT ', time4xi()) 
    try:
        task4set2event ['APU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['BPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['CPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['DPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['EPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['FPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['GPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['HPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['IPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['JPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['KPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['LPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['MPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['NPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['OPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['PPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['QPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['RPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['SPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['TPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['UPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['VPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['XPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['WPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['YPU'] ['QUEUE'] = Queue4Xi()
        task4set2event ['ZPU'] ['QUEUE'] = Queue4Xi()
        print('(Step 22B/33) OF EVENT4XI5TEST - CREATED QUEUES FOR TASK4SET2EVENT ', time4xi())    
    except:
        print('(Step 22Z/33) OF EVENT4XI5TEST *** FAILED TO CREATE QUEUES FOR TASK4SET2EVENT ', time4xi())        
    
    # ---------------------------------------------------------------------------------------------
    # (23) PIPE - EXTRA                            
    # --------------------------------------------------------------------------------------------- 
    print('(Step 23A/33) OF EVENT4XI5TEST - TRYING CREATE PIPES FOR TASK4SET2EVENT ', time4xi()) 
    try:
        task4set2event ['APU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['BPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['CPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['DPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['EPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['FPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['GPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['HPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['IPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['JPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['KPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['LPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['MPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['NPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['OPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['PPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['QPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['RPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['SPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['TPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['UPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['VPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['XPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['WPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['YPU'] ['PIPE'] = Pipe4Xi()
        task4set2event ['ZPU'] ['PIPE'] = Pipe4Xi()
        print('(Step 23B/33) OF EVENT4XI5TEST - CREATED PIPES FOR TASK4SET2EVENT ', time4xi())    
    except:
        print('(Step 23Z/33) OF EVENT4XI5TEST *** FAILED TO CREATE PIPES FOR TASK4SET2EVENT ', time4xi())  
    
    # ---------------------------------------------------------------------------------------------
    # (24) COMMAND QUEUE - EXTRA                            
    # --------------------------------------------------------------------------------------------- 
    print('(Step 24A/33) OF EVENT4XI5TEST - TRYING CREATE COMMAND QUEUE FOR TASK4SET2EVENT ', time4xi()) 
    try:
        task4set2event ['APU'] ['COMMANDQUEUE'] = create2commandqueue4apu()
        task4set2event ['BPU'] ['COMMANDQUEUE'] = create2commandqueue4bpu()
        task4set2event ['CPU'] ['COMMANDQUEUE'] = create2commandqueue4cpu()
        task4set2event ['DPU'] ['COMMANDQUEUE'] = create2commandqueue4dpu()
        task4set2event ['EPU'] ['COMMANDQUEUE'] = create2commandqueue4epu()
        task4set2event ['FPU'] ['COMMANDQUEUE'] = create2commandqueue4fpu()
        task4set2event ['GPU'] ['COMMANDQUEUE'] = create2commandqueue4gpu()
        task4set2event ['HPU'] ['COMMANDQUEUE'] = create2commandqueue4hpu()
        task4set2event ['IPU'] ['COMMANDQUEUE'] = create2commandqueue4ipu()
        task4set2event ['JPU'] ['COMMANDQUEUE'] = create2commandqueue4jpu()
        task4set2event ['KPU'] ['COMMANDQUEUE'] = create2commandqueue4kpu()
        task4set2event ['LPU'] ['COMMANDQUEUE'] = create2commandqueue4lpu()
        task4set2event ['MPU'] ['COMMANDQUEUE'] = create2commandqueue4mpu()
        task4set2event ['NPU'] ['COMMANDQUEUE'] = create2commandqueue4npu()
        task4set2event ['OPU'] ['COMMANDQUEUE'] = create2commandqueue4opu()
        task4set2event ['PPU'] ['COMMANDQUEUE'] = create2commandqueue4ppu()
        task4set2event ['QPU'] ['COMMANDQUEUE'] = create2commandqueue4qpu()
        task4set2event ['RPU'] ['COMMANDQUEUE'] = create2commandqueue4rpu()
        task4set2event ['SPU'] ['COMMANDQUEUE'] = create2commandqueue4spu()
        task4set2event ['TPU'] ['COMMANDQUEUE'] = create2commandqueue4tpu()
        task4set2event ['UPU'] ['COMMANDQUEUE'] = create2commandqueue4upu()
        task4set2event ['VPU'] ['COMMANDQUEUE'] = create2commandqueue4vpu()
        task4set2event ['XPU'] ['COMMANDQUEUE'] = create2commandqueue4wpu()
        task4set2event ['WPU'] ['COMMANDQUEUE'] = create2commandqueue4xpu()
        task4set2event ['YPU'] ['COMMANDQUEUE'] = create2commandqueue4ypu()
        task4set2event ['ZPU'] ['COMMANDQUEUE'] = create2commandqueue4zpu()
        
        print('(Step 24B/33) OF EVENT4XI5TEST - CREATED COMMAND QUEUE FOR TASK4SET2EVENT ', time4xi())    
    except:
        print('(Step 24Z/33) OF EVENT4XI5TEST *** FAILED TO COMMAND QUEUE PIPES FOR TASK4SET2EVENT ', time4xi()) 

                                                                                                                                                                                                          
    # ---------------------------------------------------------------------------------------------
    # (26) SET EVENTS TO ALL DEVICES                           
    # ---------------------------------------------------------------------------------------------
    print('(Step 26A/33) OF EVENT4XI5TEST - TRYING SET EVENTS TO ALL DEVICES  ', time4xi()) 
    try:                               
        response4set2event = cc2xi.set2event(task4set2event)                                                       
        print('(Step 26B/33) OF EVENT4XI5TEST - RESPONSE4SET2EVENT : ', response4set2event) 
        # {'DPU': {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 06:02:15 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003B139C8>, 'ACK2RETURN': ' 4B-5B-7B-8B-9B-', 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000AE8F1D0>, 'NACK2RETURN': ' 2Z1-3Z1-6Z1-', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 06:02:12 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD27C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 06:02:18 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003B13248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000B7D0320>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 06:02:12 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD27C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 4656>, <read-write PipeConnection, handle 4660>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 4352>, <read-write PipeConnection, handle 4356>)},
        #  'EPU': {'CODE2ERROR': 0 ...
        
    except:
        print('(Step 26Z/33) OF EVENT4XI5TEST *** FAILED TO SET EVENTS TO ALL DEVICES ', time4xi())   
        


                                                                                 
    # ---------------------------------------------------------------------------------------------
    # RELEASE EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 27A/33) OF EVENT4XI5TEST - RELEASING ', time4xi()) 
    print('=' *33)      
    
    task4release2event = {}
    task4release2event ['APU'] = {}
    task4release2event ['BPU'] = {}
    task4release2event ['CPU'] = {}
    task4release2event ['DPU'] = {}
    task4release2event ['EPU'] = {}
    task4release2event ['FPU'] = {}
    task4release2event ['GPU'] = {}
    task4release2event ['HPU'] = {}
    task4release2event ['IPU'] = {}
    task4release2event ['JPU'] = {}
    task4release2event ['KPU'] = {}
    task4release2event ['LPU'] = {}
    task4release2event ['MPU'] = {}
    task4release2event ['NPU'] = {}
    task4release2event ['OPU'] = {}
    task4release2event ['PPU'] = {}
    task4release2event ['QPU'] = {}
    task4release2event ['RPU'] = {}
    task4release2event ['SPU'] = {}
    task4release2event ['TPU'] = {}
    task4release2event ['UPU'] = {}
    task4release2event ['VPU'] = {}
    task4release2event ['XPU'] = {}
    task4release2event ['WPU'] = {}
    task4release2event ['YPU'] = {}
    task4release2event ['ZPU'] = {}
    
    task4release2event ['APU'] ['COUNT2REFERENCE'] = 1                                                                                                                       
    task4release2event ['BPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['CPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['DPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['EPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['FPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['GPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['HPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['IPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['JPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['KPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['LPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['MPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['NPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['OPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['PPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['QPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['RPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['SPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['TPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['UPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['VPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['XPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['WPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['YPU'] ['COUNT2REFERENCE'] = 1  
    task4release2event ['ZPU'] ['COUNT2REFERENCE'] = 1  
    
    
    try:
        release2xi = cc2xi.release2event(task4release2event)
    
        print('=' *33)          
        print('(Step 27B/33) OF EVENT4XI5TEST - RELEASED: ', release2xi)   
        # 
        print('=' *33)
    except:
        print('(Step 27Z/33) OF EVENT4XI5TEST *** FAILED TO RELEASE ', time4xi()) 
        
                                                                                   
    # ---------------------------------------------------------------------------------------------
    # RETAIN EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 28A/33) OF EVENT4XI5TEST - RETAIN ', time4xi())
    print('=' *33)      
    task4retain2event = {}
    task4retain2event ['APU'] = {}
    task4retain2event ['BPU'] = {}
    task4retain2event ['CPU'] = {}
    task4retain2event ['DPU'] = {}
    task4retain2event ['EPU'] = {}
    task4retain2event ['FPU'] = {}
    task4retain2event ['GPU'] = {}
    task4retain2event ['HPU'] = {}
    task4retain2event ['IPU'] = {}
    task4retain2event ['JPU'] = {}
    task4retain2event ['KPU'] = {}
    task4retain2event ['LPU'] = {}
    task4retain2event ['MPU'] = {}
    task4retain2event ['NPU'] = {}
    task4retain2event ['OPU'] = {}
    task4retain2event ['PPU'] = {}
    task4retain2event ['QPU'] = {}
    task4retain2event ['RPU'] = {}
    task4retain2event ['SPU'] = {}
    task4retain2event ['TPU'] = {}
    task4retain2event ['UPU'] = {}
    task4retain2event ['VPU'] = {}
    task4retain2event ['XPU'] = {}
    task4retain2event ['WPU'] = {}
    task4retain2event ['YPU'] = {}
    task4retain2event ['ZPU'] = {}
    
    task4retain2event ['APU'] ['COUNT2REFERENCE'] = 1                                                                                                                     
    task4retain2event ['BPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['CPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['DPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['EPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['FPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['GPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['HPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['IPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['JPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['KPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['LPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['MPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['NPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['OPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['PPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['QPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['RPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['SPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['TPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['UPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['VPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['XPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['WPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['YPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2event ['ZPU'] ['COUNT2REFERENCE'] = 1    
    
    try:
        
        retain2xi = cc2xi.retain2event(task4retain2event)
    
        print('=' *33)          
        print('(Step 28B/33) OF EVENT4XI5TEST - RETAINED: ', retain2xi)  
        # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 06:02:15 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2event4dpu', 'METHOD': 'create2event4dpu'}, 'FUNCTION2CALLBACK': <function trace2event4dpu at 0x0000000003B139C8>, 'ACK2RETURN': ' 1D-', 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000AE8F1D0>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 06:02:12 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD27C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'COMMANDQUEUE': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2commandqueue4dpu-failed ; time: 06:02:18 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2commandqueue4dpu', 'METHOD': 'create2commandqueue4dpu'}, 'FUNCTION2CALLBACK': <function trace2commandqueue4dpu at 0x0000000003B13248>, 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-8A-9B-10B-9B-10B-11B-12B-13B-14B-15B-16B-17B-18B-', 'INFO2PRIVATE': None, 'QUEUE': <queue4xi.Queue4Xi object at 0x000000000B7D0320>, 'NACK2RETURN': ' ', 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 06:02:12 08/26/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003FD27C8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PROPERTIES': None, 'PIPE': (<read-write PipeConnection, handle 4656>, <read-write PipeConnection, handle 4660>)}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'PIPE': (<read-write PipeConnection, handle 4352>, <read-write PipeConnection, handle 4356>)}, 
        #  'EPU': ... 
        
        print('=' *33)
    except:
        print('(Step 28Z/33) OF EVENT4XI5TEST *** FAILED TO RETAIN ', time4xi())            
        
                                                                                                          
    # ---------------------------------------------------------------------------------------------
    # TRACE EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33A/33) OF EVENT4XI5TEST - SENSING ', time4xi())
    print('=' *33)      
    
    try:
        trace2xi = cc2xi.trace2event()
    
        print('=' *33)          
        print('(Step 33B/33) OF EVENT4XI5TEST - TRACED ', time4xi())  
        # 06:02:21 08/26/11 Pacific Daylight Time
        
        print('=' *33)
    except:
        print('(Step 33Z1/33) OF EVENT4XI5TEST *** FAILED TO TRACE ', time4xi())     
                                                                                                          
    # ---------------------------------------------------------------------------------------------
    # WAIT EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33A/33) OF EVENT4XI5TEST - WAITING ', time4xi())
    print('=' *33)      
    
    try:
        wait2xi = cc2xi.wait2event()
    
        print('=' *33)          
        print('(Step 33B/33) OF EVENT4XI5TEST - WAITED ', time4xi()) 
        # 06:02:21 08/26/11 Pacific Daylight Time
        
        print('=' *33)
    except:
        print('(Step 33Z1/33) OF EVENT4XI5TEST *** FAILED TO WAIT ', time4xi())     
                                                                                                          
    # ---------------------------------------------------------------------------------------------
    # SENSE EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33A/33) OF EVENT4XI5TEST - SENSING ', time4xi())
    print('=' *33)      
    
    try:
        print(cc2xi.sense())
    
        print('=' *33)          
        print('(Step 33B/33) OF EVENT4XI5TEST - SENSED ', time4xi()) 
        # 06:02:21 08/26/11 Pacific Daylight Time
        
        print('=' *33)
    except:
        print('(Step 33Z1/33) OF EVENT4XI5TEST *** FAILED TO SENSE ', time4xi())          
        
    # ---------------------------------------------------------------------------------------------
    # REASON EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33C/33) OF EVENT4XI5TEST - REASONING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.reason())
    
        print('=' *33)          
        print('(Step 33D/33) OF EVENT4XI5TEST - REASONED ', time4xi())
        # REASONED  06:02:21 08/26/11 Pacific Daylight Time
        
        print('=' *33)       
    except:
        print('(Step 33Z2/33) OF EVENT4XI5TEST *** FAILED TO REASON ', time4xi())                                   
             
    # ---------------------------------------------------------------------------------------------
    # ACE EVENTS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33E/33) OF EVENT4XI5TEST - ACING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.ace())
    
        print('=' *33)          
        print('(Step 33F/33) OF EVENT4XI5TEST - ACED ', time4xi())                                                 
        # 06:02:21 08/26/11 Pacific Daylight Time
        
        print('=' *33) 
    except:
        print('(Step 33Z3/33) OF EVENT4XI5TEST *** FAILED TO ACE ', time4xi())                                       
     
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33/33) OF EVENT4XI5TEST - DONE! ', time4xi())
    # 06:02:21 08/26/11 Pacific Daylight Time                                         
    print('=' *33) 
   
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for event4xi5test
#"> 

# -------------------------------------------------------------------------------------------------    
def main():
    global trace2scope
    global trace_object_count    
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    trace2scope = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test          
    print('=' *33)
    print("(Step 0A/700) OF EVENT4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi()) 
    # 
    print('=' *33)    
    try:     
        
        event4xi5test()  
        
        print('=' *33)
        print("(Step 0B/33) OF EVENT4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi()) 
        # 
        print('=' *33) 
    except:
        pass
    finally: 
        # ---------------------------------------------------------------------------------------------    
        # FINALLY PRINT TRACE WHATEVER HAPPENS
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(trace2scope)                                
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# event4xi5test.txt
# sense-event4xi5test.xml
# reason-event4xi5test.xml
# ace-event4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of event4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
